<?php

// Copyright 2010 Sleepless Software Inc. All Rights Reserved

/*
Example usage:

	// defining this is optional.  if not defined, default will be as shown
	$salt = $_SERVER["REMOTE_ADDR"].$_SERVER["HTTP_USER_AGENT"].date("d");

	// optional, but if not defined, session handling is effectively disabled
	$auth_list = array(
		"username"=>"password",
	);

	require_once "sleepylib/session.php";
	// $authkey will be non-blank on return if existing, valid session detected

	if($act == "login") {
		$authkey = authenticate($_REQUEST["user"], $_REQUEST["pass"]);
		exit;
	}

*/

if(!isset($salt)) 
	$salt = $_SERVER["REMOTE_ADDR"].$_SERVER["HTTP_USER_AGENT"].date("d");
if(!isset($auth_list))
	$auth_list = array();

$username = $_COOKIE["username"];

$authkey = $_COOKIE["sid"];
if($authkey) {
	// key present - verify session
	$tmpkey = $authkey;
	$authkey = "";
	foreach($auth_list as $u => $p) {
		$u = strtolower(trim($u));
		$p = strtolower(trim($p));
		$k = sha1($u.$p.$salt);
		if($k == $tmpkey) {
			// freshen session 
			$authkey = $k;
			$username = $u;
		}
	}
	setcookie("sid", $authkey, time() + (15 * 60));
}

function authenticate($pass, $user) {
	global $auth_list, $salt, $authkey, $username;
	dbg("salt is $salt ");
	dbg("auth $user/$pass ... ");
	$user = strtolower(trim($user));
	$pass = strtolower(trim($pass));
	foreach($auth_list as $u => $p) {
		$u = strtolower(trim($u));
		$p = strtolower(trim($p));
		dbg("testing $user=$u and $pass=$p or ".sha1($pass)."=$p");
		if($user == $u && ($pass == $p || sha1($pass) == $p)) {
			// login ok
			$authkey = sha1($u.$p.$salt);
			setcookie("sid", $authkey, time() + (15 * 60));
			$username = $user;
			setcookie("username", $username, time() + (30 * 24 * 60 * 60));
			dbg("login ok ... key=$authkey ");
			return $authkey;
		}
	}
	return null;
}

function authclear() {
	setcookie("sid", "", time());
}

if($authkey)
	dbg("username=$username authkey=$authkey");

?>
