<?	/* Copyright 2009 Sleepless Software Inc.  All Rights Reserved */


require_once "adodb/adodb.inc.php";
$db = ADONewConnection('mysql');
$db->Connect($dbhost, $dbuser, $dbpass, $dbdb);


function p_sqlfail($db, $sql)
{
	global $dbg;

	$msg = "BAD MOJO:<p>".$db->ErrorMsg()."<br>SQL: ".$sql;
	throw new Exception($msg);	// XXX
	exit;
}

function logit($who, $act, $det)
{
	global $db;

	$who = addslashes($who);
	$act = addslashes($act);
	$det = addslashes($det);
	$sql = "insert into log (who,action,detail) values ('$who','$act','$det')";
	// I don't call dbExec here, becuase that calls logit()!
	$rs = $db->Execute($sql);
	if(!$rs)
		p_sqlfail($db, $sql);
}


function dbExec($sql, $vars = null)
{
	global $db, $dbg, $uid;

	if($vars != null)
		$rs = $db->Execute($sql, $vars);
	else
		$rs = $db->Execute($sql);
	if(!$rs)
		p_sqlfail($db, $sql);

	return $rs;
}

function insID()
{
	global $db;
	return $db->Insert_ID();
}

function getfld($field, $table, $where)
{
	global $db;
	$sql = "select $field from $table $where";
	$rs = dbExec($sql);
	return $rs->fields(0);
}

function getField($table, $field, $where)
{
	global $db;
	$sql = "select $field from $table $where";
	$rs = dbExec($sql);
	return $rs->fields(0);
}

function recArray($sql, $vars = null)
{
    $a = array();
    $rs = dbExec($sql, $vars);
    while(!$rs->EOF)
        array_push($a, $rs->FetchNextObj());
    return $a;
}

function dbGetAssoc($sql)
{
	global $db;
	$a = $db->GetAssoc($sql);
	if(!$a)
		return array(); //p_sqlfail($db, $sql);
	return $a;
}

function recObj($sql, $vars = null)
{
	$rs = dbExec($sql, $vars);
	return ($rs->RecordCount() < 1) ? null : $rs->FetchNextObj();
}

function getone($sql, $vars = null)
{
    global $db;
    return dbExec($sql, $vars)->fields(0);
}


/* Encodes a string for output in a CSV file.  I first replace
double-quotes with doubled double-quotes, then surround everything
with double quotes.  This should successfully protect double-quotes,
commas and newlines (hopefully any other char) in the field so
that they will be loaded into Excel properly. */
function csv_encoded($s)
{
    $pat = "/\"/";
    $rep = "\"\"";
    $s = preg_replace($pat, $rep, $s);
    $s = "\"".$s."\"";
    return $s;
}


function exp_query($sql, $fname = "data.csv")
{
    $rs = dbExec($sql);

    header('Content-Type: text/csv');
    header("Content-Disposition: attachment; filename=\"$fname\"");

    // Dump column names
    $fc = $rs->FieldCount();
    for($i = 0; $i < $fc; $i++)
    {
        $f = $rs->FetchField($i);
        $fn = $f->name;
        if($i != 0)
            print(",");
        print(csv_encoded($fn));
    }
    print("\n");

    // Dump data
    $rc = $rs->RecordCount();
    while(!$rs->EOF)
    {
        for($i = 0; $i < $fc; $i++)
        {
            $v = $rs->Fields($i);
            if($i != 0)
                print(",");
            print(csv_encoded($v));
        }
        print("\n");
        $rs->MoveNext();
    }
}


?>
