// Copyright 2009 Sleepless Software Inc.  All Rights Reserved
EON =
{
	o2e:function (obj)
	{
		if(typeof obj === 'string')
		{
			return '"'+escape(obj)+'"';
		}
		else
		if(obj instanceof Array)
		{
			var s = "";
			var l = obj.length;
			for(var i = 0; i < l; i++)
			{
				if(i != 0)
					s += ",";
				s += EON.o2e(obj[i]);
			}
			return "["+escape(s)+"]";
		}
		else
		if(obj instanceof Function)
		{
			return '"function"';
		}
		else
		if(obj instanceof Object)
		{
			var i = 0;
			var s = "";
			for(var prop in obj) {
				if(i != 0)
					s += ",";
				s += prop+":"+EON.o2e(obj[prop]);
				i++;
			}
			return "{"+escape(s)+"}";
		}
		return obj;
	},
	e2o:function (eon)
	{
		if(typeof eon === 'string')
		{
			if(eon.match(/^\[[A-Za-z0-9%\/\.]*\]$/))
			{
				if(eon.match(/^\[\]$/))
					return [];
				var a = unescape(eon.substring(1, eon.length - 1)).split(',');
				var l = a.length;
				for(var i = 0; i < l; i++)
					a[i] = EON.e2o(a[i]);
				return a;
			}
			else
			if(eon.match(/^\{[A-Za-z0-9%\/\.]*\}$/))
			{
				var o = {};
				if(eon.match(/^\{\}$/))
					return o;
				var a = unescape(eon.substring(1, eon.length - 1)).split(',');
				var l = a.length;
				for(var i = 0; i < l; i++)
				{
					var a2 = a[i].split(':');
					if(a2.length == 2)
					{
						if(a2[0].match(/^[A-Za-z0-9_]+$/))
						{
							eval("o."+a2[0]+"=EON.e2o(a2[1])");
						}
					}
				}
				return o;
			}
			else
			if(eon.match(/^"[A-Za-z0-9%\/\.]*"$/))
			{
				return unescape(eon.substring(1, eon.length - 1));
			}
			else
			if(eon.match(/^[-+]?[0-9]*\.?[0-9]+([eE][-+]?[0-9]+)?$/))
			{
				return parseFloat(eon);
			}
			else
			if(eon.match(/^[0-9]+$/))
			{
				return parseInt(eon);
			}
			else
			if(eon == "NaN")
			{
				return NaN;
			}
		}
		return null;
	}
};


var orig = {foo:"bar", zen:123, arr:["x","y","z"]}
console.log(orig)
var enc = EON.o2e(orig)
console.log(enc)
var dec = EON.e2o(enc)
console.log(dec)



