<?

if(is_file("lib/tigra_calendar/inc.php"))
	include_once "lib/tigra_calendar/inc.php";


class FInput
{
	function __construct($n = "", $v = "", $i = "", $c = "", $e = "", $l = "")
	{
		$this->template = "
			<input
				type='[type]'
				name='[name]'
				id='[id]'
				class='[class]'
				value='[value]'
				[extra]
				>";
		$this->type = "text";
		$this->name = $n;
		$this->value = $v;
		$this->id = $i;
		$this->class = $c;
		$this->extra = $e;
		$this->label = $l;
	}

	function pr($t, $o)
	{
		return preg_replace("|\[$t\]|", $this->$t, $o);
	}

	function tostr()
	{
		$out = $this->template;
		unset($this->template);
		//dbg($this);
		foreach($this as $tag => $val)
			$out = $this->pr($tag, $out);
		return $out."\n";
	}
}

class FPassword extends FInput
{
	function __construct($n = "", $v = "", $i = "", $c = "", $e = "", $l = "")
	{
		parent::__construct($n, $v, $i, $c, $e, $l);
		$this->type = "password";
	}
}

class FTextArea extends FInput
{
	function __construct($n = "", $v = "", $i = "", $c = "", $e = "", $l = "")
	{
		parent::__construct($n, $v, $i, $c, $e, $l);
		$this->template = "
			<textarea
				name='[name]'
				id='[id]'
				class='[class]'
				[extra] >[value]</textarea
				>";
	}
}

class FRadio extends FInput
{
	function __construct($n = "", $v = "", $i = "", $c = "", $e = "", $l = "")
	{
		parent::__construct($n, $v, $i, $c, $e, $l);
		$this->type = "radio";
	}
}

class FCheckBox extends FInput
{
	function __construct($n = "", $v = "", $i = "", $c = "", $e = "", $l = "")
	{
		$onchange = 'var e = document.getElementById("HID_[name]"); e.value=(this.checked?1:0); e.onchange();';
		$cbox = "
			<input
				type='checkbox'
				id='[id]'
				onchange='$onchange'
				".($v ? "checked" : "")."
				>";
		if(preg_match("/readonly/", $e))
		{
			//$onchange = 'this.checked = (document.getElementById("HID_[name]").value == 1) ? true : false;';
			$cbox = $v ? "X" : "&nbsp;";
		}


		parent::__construct($n, $v, $i, $c, $e, $l);
		$this->template = "
			<input
				type='hidden'
				name='[name]'
				id='HID_[name]'
				value='".($v ? 1 : 0)."'
				[extra]
				>
			$cbox
				";
	}

}

class FSubmit extends FInput
{
	function __construct($n = "", $v = "", $i = "", $c = "", $e = "", $l = "")
	{
		parent::__construct($n, $v, $i, $c, $e, $l);
		$this->type = "submit";
	}
}

class FHidden extends FInput
{
	function __construct($n = "", $v = "", $i = "", $c = "", $e = "", $l = "")
	{
		parent::__construct($n, $v, $i, $c, $e, $l);
		$this->type = "hidden";
	}
}

class FOption extends FInput
{
	function __construct($n = "", $v = "", $i = "", $c = "", $e = "", $l = "")
	{
		parent::__construct($n, $v, $i, $c, $e, $l);
		$this->template = "
			<option
				id='[id]'
				class='[class]'
				value='[value]'
				[extra] >
				[label]
				</option>";
		$this->label = $l;
	}
}

class FSelect extends FInput
{
	function __construct($n = "", $v = "", $i = "", $c = "", $e = "", $l = "")
	{
		parent::__construct($n, $v, $i, $c, $e, $l);
		$this->template = "
			<select
				name='[name]'
				id='[id]'
				class='[class]'
				[extra] >
				[options]
				</select>";
		if(is_array($v))
		{
			unset($this->value);
			foreach($v as $val => $lab)
				$this->option("", $val, "", "", "", $lab);
		}
	}

	function option($n = "", $v = "", $i = "", $c = "", $e = "", $l = "")
	{
		$o = new FOption($n, $v, $i, $c, $this->extra.$e, $l);
		//dbg($o);
		$this->options .= $o->tostr();
	}
}

class FDate extends FInput
{
	function __construct($n = "", $v = "", $i = "", $c = "", $e = "", $l = "")
	{
		$i = time();
		parent::__construct($n, $v, $i, $c, $e, $l);
		//$this->extra .= " onclick='cal_$n.popup()' ";
		$this->template .= "
			<script>
				var cal_[name] = new calendar3(document.getElementById('$i'));
				cal_[name].year_scroll = true;
				cal_[name].time_comp = [tmcmp];
				function onld_$i(e)
				{
					if(document.getElementById('$i').readOnly)
						e.style.display= 'none';
				}
			</script>
			<img
				style='cursor: pointer; cursor: hand;'
				src='../media/cal.gif'
				border='0'
				onload='onld_$i(this)'
				onclick='cal_$n.popup()'>
			";
		$this->tmcmp = "false";
	}
}

class FTimeStamp extends FDate
{
	function __construct($n = "", $v = "", $i = "", $c = "", $e = "", $l = "")
	{
		parent::__construct($n, $v, $i, $c, $e, $l);
		$this->tmcmp = "true";
	}
}




function ff($fc, $n="", $v="", $i="", $c="", $e="", $l="")
{
	$o = new $fc($n, $v, $i, $c, $e, $l);
	return $o->tostr();
}




function ff_txt($n, $v = "", $id = "", $c = 50, $r = 4)
{
	return "<textarea cols='$c' rows='$r' name='$n' id='$id'>$v</textarea>";
}

function ff_hid($n, $v = "", $id = "")
{
	return "<input type='hidden' name='$n' id='$id' value=\"$v\">";
}

function ff_str($n, $v = "", $id = "", $s = 80, $m = 255)
{
	$v = preg_replace("/\"/", "&quot;", $v);
	return "
		<input type='text' name='$n' id='$id' value=\"$v\" size='$s' maxlength='$m'> 
		";
}

function ff_int($n, $v = "", $id = "", $s = 20, $m = 20)
{
	// xxx add validation, then just throw exception on serverside
	return "
		<input type='text' name='$n' id='$id' value='$v'> 
		";
}

function ff_submit($v = "Submit")
{
	// xxx add validation, then just throw exception on serverside
	return "
		<input type='submit' value='$v'> 
		";
}

function ff_uint($n, $v = "", $id = "", $s = 20, $m = 20)
{
	// xxx add validation, then just throw exception on serverside
	return ff_int($n, $v, $id);
}

function ff_check($n, $c = false, $id = "")
{
	$checked = $c ? "checked" : "";
	return "
		<input type='hidden' name='$n' id='H_$n' value='".($c?1:0)."'> 
		<input type='checkbox' id='$id' $checked
			onchange='document.getElementById(\"H_$n\").value=(this.checked?1:0);'
			>
		";	
}


function ff_date($n, $v = "", $id = "")
{
	return "<input
		type=\"text\"
		name=\"$n\"
		id=\"$id\"
		value=\"$v\"
		onclick=\"cal_$n.popup()\">
		<script>
			var cal_$n = new calendar3(document.getElementById(\"$id\"));
			cal_$n.year_scroll = true;
			cal_$n.time_comp = false;
		</script>
		";
}

function ff_timestamp($n, $v = "", $id = "")
{
	return "<input
		type=\"text\"
		name=\"$n\"
		id=\"$id\"
		value=\"$v\"
		onclick=\"cal_$n.popup()\">
		<script>
			var cal_$n = new calendar3(document.getElementById(\"$id\"));
			cal_$n.year_scroll = true;
			cal_$n.time_comp = true;
		</script>
		";
}

function ff_first_name($v = "")
{
	return ff("FInput", "first_name", $v, "first_name", "", "size='30'");
}

function ff_last_name($v = "")
{
	return ff("FInput", "last_name", $v, "last_name", "", "size='30'");
}

function ff_nick_name($v = "")
{
	return ff("FInput", "nick_name", $v, "nick_name", "", "size='30'");
}

function ff_zip_code($v = "")
{
	return ff("FInput", "zip_code", $v, "zip_code", "", "size='12'");
}

function ff_email($v = "", $n = "email")
{
	return ff("FInput", $n, $v, $n, "", "size='30'");
}

function ff_password($v = "")
{
	return ff("FPassword", "password", $v, "password", "", "size='30'");
}

?>

