
// return mirrored/reversed copy of a string
var flip = function(s) {
	var a = s.split("")
	a = a.reverse()
	return a.join("")
}

Fogger = {

	/* obfuscates a string.
		Returned string may be (and typically is) longer than the original.
		The increased length will typically be less than calling escape() on the string.
		The increase will be less for strings with higher proportion of 7-bit alphanumeric characters
		Returned string is ALREADY ENCODED for inclusion in a URL query; no need to escape() it
		Should handle utf8 fine
		*/
	befog: function(s) {
		s = escape(s)
		s = s.replace(/\//g, "%2F")
		s = s.replace(/-/g, "%2D")
		s = s.replace(/_/g, "%5F")
		s = s.replace(/\*/g, "%2A")
		s = s.replace(/\+/g, "%2B")
		s = s.replace(/@/g, "%40")
		s = s.replace(/\./g, "%2E")
		s = s.replace(/%/g, "/")
		s = s.replace(/e/g, "-")
		s = s.replace(/t/g, "_")
		s = s.replace(/\/7/g, "*")
		s = s.replace(/\/5/g, "+")
		s = s.replace(/\/3/g, "@")
		s = s.replace(/\/2/g, ".")
		s = flip(s)
		return s
	},

	/* unobfuscates a string
		Reverses the effects of "befog()"
		*/
	unfog: function(s) {
		s = flip(s)
		s = s.replace(/\./g, "/2")
		s = s.replace(/@/g, "/3")
		s = s.replace(/\+/g, "/5")
		s = s.replace(/\*/g, "/7")
		s = s.replace(/_/g, "t")
		s = s.replace(/-/g, "e")
		s = s.replace(/\//g, "%")
		s = s.replace(/%2E/g, ".")
		s = s.replace(/%40/g, "@")
		s = s.replace(/%2B/g, "+")
		s = s.replace(/%2A/g, "*")
		s = s.replace(/%5F/g, "_")
		s = s.replace(/%2D/g, "-")
		s = s.replace(/%2F/g, "/")
		s = unescape(s)
		return s
	}
}


test = function(o) {
	console.log("------------")
	console.log("original: "+o+"\n")
	console.log("orig+esc: "+escape(o)+"\n")
	var e = Fogger.befog(o)
	console.log("befogged: "+e+"\n")
	console.log("escaped : "+escape(e)+"\n")
	var d = Fogger.unfog(e)
	console.log("unfogged: "+d+"\n")

	var diff = e.length - o.length
	var perc = Math.floor((diff / o.length) * 100)

	if(o == d)
		console.log("**PASS!**: length increase: "+perc+" %\n")
	else
		console.log("Fail )-: \n")
}

test("!#$%^&(),=[]{}<>\\|~\";:`  Mary had a little lamb, it's fleece was .... ")
test("[{\"q\":\"Pugh-1296007494531-15\",\"vid\":1161,\"m\":\"getvlgrmem\",\"sid\":\"7276586e545afdd84f63ef2d9aecca1c5e9f731b\",\"uid\":100001657565391},\"data\":\"star-*__at-@__plus-+__dot-.\", setsid ping login getjobtypes getbldgtypes getnbrs prefs expmny updcnt startjob clrjob rcvrjob helpjob mkvlgr getvlgrs updvlgr delvlgr mkast getasts2 updast delast mkbldg getbldgs updbldg delbldg updfbflassc getfbtrassc delfbflassc")
test("[{\"t\":1296026921702,\"q\":\"Snow-1296003662289-4482\",\"r\":0,\"m\":\"pong\",\"ts\":1296026921702}]")
test("%2F The frequency of letters in text has often been studied for use in cryptography, and frequency analysis in particular. No exact letter frequency distribution underlies a given language, since all writers write slightly differently.")

