#ifndef sleepless_jumboextractor_cpp
#define sleepless_jumboextractor_cpp



//#include "../lib/inflater.cpp"
#include "inflater.cpp"


struct JumboExtractor
{
	Inflater *inflater;

	JumboExtractor(int (*rf)(void *handle, char *buf, int len), void *rh)
	{
		ep = 0;
		ef[0] = 0;
		inflater = new Inflater(rf, rh);
	}

	~JumboExtractor()
	{
		delete inflater;
	}



	char ef[300];
	char *ep;
	const char *lastError()
	{
		return ep;
	}
	const char *lastFile()
	{
		return ef;
	}



	char buf[50000];

	int copy(FILE *fp, int len)
	{
		int wrote = 0;
		int r;
		int w;
		while(wrote < len)
		{
			unsigned long rem = len - wrote;
			unsigned long readLen = (rem < sizeof(buf)) ? rem : sizeof(buf);

			r = inflater->read(buf, readLen);
			w = (int)fwrite(buf, 1, r, fp);
			wrote += w;

			if(ferror(fp) || inflater->getError())
				return -1;
		}
		return wrote;
	}


	int skip(int len)
	{
		int wrote = 0;
		while(wrote < len)
		{
			unsigned long rem = len - wrote;
			unsigned long readLen = (rem < sizeof(buf)) ? rem : sizeof(buf);
			wrote += inflater->read(buf, readLen);
			if(inflater->getError())
				return -1;
		}
		return wrote;
	}




	char *gets(char *buf, int len)
	{
		len -= 1;
		char *b = buf;
		int n;
		for(n = 0; n < len; n++, b++)
		{
			if(inflater->read(b, 1) != 1)
			{
				*b = 0;
				return NULL;
			}
			if(*b == 13)			// ignore CR's
			{
				b--;
				continue;
			}
			if(*b == 10)
				break;
		}
		b++;
		*b = 0;
		return buf;
	}


#ifdef WIN32
	int mkdir(const char *file, int)
	{
		char *tfile = _strdup(file);						// clone string
		char *s = tfile;
		while(*s) { if(*s == '/') *s = '\\'; s++; }		// Convert '/' to '\'
		int r = _mkdir(tfile);					// make the dir
		free(tfile);									// dispose of cloned str
		return r;
	}
#endif


	char s[5000];

	int extract(bool listonly)
	{
		if(!gets(s, sizeof(s)))
		{
			ep = "not a jumbo file (1)";
			return -1;
		}

		if(strncmp(s, "Jumbo\n", 6) != 0)
		{
			ep = "not a jumbo file (2)";
			return -1;
		}
	
		while(true)
		{
			if(!gets(s, sizeof(s)))
			{
				// finish normally
				break;
			}

			if(strcmp(s, "d\n") == 0)
			{
				if(!gets(s, sizeof(s)))
				{
					ep = "can't read dir name";
					return -1;	
				}
				if(s[strlen(s) - 1] == '\n')
					s[strlen(s) - 1] = 0;
				if((strcmp(s, ".") != 0) && (strcmp(s, "..") != 0))
				{
					if(listonly)
					{
						fprintf(stdout, "%s\n", s);
					}
					else
					{
						// Don't really want to fail here, so ignore result
//fprintf(stdout, "mkdir %s\n", s);
						mkdir(s, 0777);
					}
				}
			}
			else
			if(strcmp(s, "f\n") == 0)
			{
				if(!gets(s, sizeof(s)))
				{
					ep = "can't read file size";
					return -1;	
				}
				int fsize = atol(s);
				if(!gets(s, sizeof(s)))
				{
					ep = "can't read file name";
					return -1;	
				}
				if(s[strlen(s) - 1] == '\n')
					s[strlen(s) - 1] = 0;


				if(listonly)
				{
					fprintf(stdout, "%s\n", s);
					int rr = skip(fsize);
					if(rr != fsize)
					{
						ep = "scan error";
						return -1;
					}
				}
				else
				{
//fprintf(stdout, "write %s (%d)\n", s, fsize);
					STR_CPY(ef, s);
					FILE *fp = fopen(s, "wb");
					if(!fp)
					{
						ep = "can't open file for writing";
						return -1;
					}

					int rr = copy(fp, fsize);

					fclose(fp);

					if(rr != fsize)
					{
						ep = "extraction error";
						return -1;
					}
				}
			}
			else
			{
				ep = "[unrecognized archive entry!]";
				return -1;
			}
		}

		return 0;
	}




};







#endif	

