#ifndef com_sleepless_kcuf_h
#define com_sleepless_kcuf_h


/*
Kludgey Communication Using Files
Copyright 2009 - Sleepless Software Inc. - All Rights Reserved
*/

#include <stdio.h>

#include "string.cpp"
#include "file.cpp"

struct KCUF
{
	S in;
	S out;
	File *fin;
	File *fout;

	// p is prefix for com files, i.e., "/tmp/sswat", which would result in com
	// files of "/tmp/sswat.kcuf-in" and "/tmp/sswat.kcuf-out".
	// 
	KCUF(const char *p = 0)
	{
		if(p)
		{
			in.set(p);
			out.set(p);
		}
		in.cat("kcuf-in");
		out.cat("kcuf-out");
		fin = new File(in);
		fout = new File(out);
	}


	// returns -1 if it couldn't write, otherwise returns # of bytes written
	int write(const char *msg)
	{
		if(fout)
			return fout->putBytes(msg);
		return -1;
	}

	// may return null
	const unsigned char *read()
	{
		if(fin)
			return fin->getBytes();
		return 0;
	}

};

#endif		// com_sleepless_kcuf_h
