#ifndef com_sleepless_mthttpd_cpp
#define com_sleepless_mthttpd_cpp

/* Copyright 1998-2002 Sleepless Software Inc.  All Rights Reserved */



/*

	HTTP Request Headers
	---------------------

	Netscape 6.0 Linux
		GET / HTTP/1.1
		Host: localhost:8888
		User-Agent: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:0.9.2) Gecko/20010726 Netscape6/6.1
		Accept: text/xml, application/xml, application/xhtml+xml, text/html;q=0.9, image/png, image/jpeg, image/gif;q=0.2, text/plain;q=0.8, text/css, asterisk/asterisk;q=0.1
		Accept-Language: en-us
		Accept-Encoding: gzip,deflate,compress,identity
		Accept-Charset: ISO-8859-1, utf-8;q=0.66, *;q=0.66
		Keep-Alive: 300
		Connection: keep-alive
	
	IE 5.1 Mac
		GET / HTTP/1.1
		Host: hitchens-pbdsl4.stanford.edu:8888
		Accept: asterisk/asterisk
		Accept-Language: en
		Connection: Keep-Alive
		User-Agent: Mozilla/4.0 (compatible; MSIE 5.12; Mac_PowerPC)
		UA-OS: MacOS
		UA-CPU: PPC
		Extension: Security/Remote-Passphrase

	Lynx Linux
		GET / HTTP/1.0
		Host: hitchens-pbdsl4.stanford.edu:8888
		Accept: text/html, text/plain, audio/mod, image/asterisk, video/asterisk, video/mpeg, application/pgp, application/pgp, application/pdf, message/partial, message/external-body, application/postscript, x-be2, application/andrew-inset, text/richtext, text/enriched
		Accept: x-sun-attachment, audio-file, postscript-file, default, mail-file, sun-deskset-message, application/x-metamail-patch, application/msword, text/sgml, video/mpeg, image/jpeg, image/tiff, image/x-rgb, image/png, image/x-xbitmap, image/x-xbm
		Accept: image/gif, application/postscript, asterisk/asterisk;q=0.01
		Accept-Encoding: gzip, compress
		Accept-Language: en
		User-Agent: Lynx/2.8.4dev.16 libwww-FM/2.14 SSL-MM/1.4.1 OpenSSL/0.9.6
 
	Netscape 4.72 Mac
		GET / HTTP/1.0
		Connection: Keep-Alive
		User-Agent: Mozilla/4.72 (Macintosh; U; PPC)
		Host: hitchens-pbdsl4.stanford.edu:8888
		Accept: image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, image/png, asterisk/asterisk
		Accept-Encoding: gzip
		Accept-Language: en
		Accept-Charset: iso-8859-1,*,utf-8
 





	HTTP Response Headers
	-----------------------

	Me!?
		HTTP/1.0 200 OK
		Server: MTHTTPDaemon 1.0
		Cache-Control: no-cache
		Expires: Wed, 23 Aug 2000 20:25:05 GMT
		Content-Location: http://204.202.128.139/index.html
		Set-Cookie: SWID=D00A460A-7931-11D4-8206-00A0C9F48700; path=/; expires=Wed, 23-Aug-2020 20:25:05 GMT; domain=.go.com;
		Date: Wed, 23 Aug 2000 20:25:05 GMT
		Content-Type: text/html
		Accept-Ranges: bytes
		Last-Modified: Wed, 23 Aug 2000 20:21:02 GMT
		Content-Length: 27045

	www.yahoo.com
		HTTP/1.0 200 OK
		Date: Fri, 25 Jan 2002 05:48:00 GMT
		Connection: close
		Content-Type: text/html

	www.sleepless.com
		HTTP/1.1 200 OK
		Date: Fri, 25 Jan 2002 05:45:36 GMT
		Server: Apache
		Last-Modified: Wed, 23 Jan 2002 08:01:12 GMT
		ETag: "194048-7cc-3c4e6dc8"
		Accept-Ranges: bytes
		Content-Length: 1996
		Connection: close
		Content-Type: text/html

	www.microsoft.com
		HTTP/1.1 200 OK
		Server: Microsoft-IIS/5.0
		P3P: CP='ALL IND DSP COR ADM CONo CUR CUSo IVAo IVDo PSA PSD TAI TELo OUR SAMo CNT COM INT NAV ONL PHY PRE PUR UNI'
		Content-Location: http://cpmsftwbw06/default.htm
		Date: Fri, 25 Jan 2002 05:45:06 GMT
		Content-Type: text/html
		Accept-Ranges: bytes
		Last-Modified: Thu, 24 Jan 2002 17:55:26 GMT
		ETag: "281fcb4d0a5c11:866"
		Content-Length: 26999



	File uploading
	---------------------

	This is what IE 6.0 sends for a file upload POST

		POST /testie HTTP/1.1
		Accept: image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, application/vnd.ms-powerpoint, application/vnd.ms-excel, application/msword, asterisk/asterisk
		Accept-Language: en-us
		Content-Type: multipart/form-data; boundary=---------------------------7d2db3a190134
		Accept-Encoding: gzip, deflate
		User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)
		Host: home.sleepless.com:3333
		Content-Length: 417
		Connection: Keep-Alive
		Cache-Control: no-cache'
 
		-----------------------------7d2db3a190134
		Content-Disposition: form-data; name="bloo"; filename="D:\Sleepless Software\foo\test.html"
		Content-Type: text/html

		<html>
		<body>
		<form 
			method=post
			enctype="multipart/form-data"
			action="http://home.sleepless.com:3333/testie"
			>

		<input name=bloo type="file">
		<input type="submit" value="upload">

		</form>

		-----------------------------7d2db3a190134--


	This is what Netscape 6.2 sends for a file upload POST

		POST /test HTTP/1.1
		Host: localhost:3333
		User-Agent: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:0.9.4.1) Gecko/20020314 Netscape6/6.2.2
		Accept: text/xml, application/xml, application/xhtml+xml, text/html;q=0.9, image/png, image/jpeg, image/gif;q=0.2, text/plain;q=0.8, text/css, asterisk/asterisk;q=0.1
		Accept-Language: en-us
		Accept-Encoding: gzip, deflate, compress;q=0.9
		Accept-Charset: ISO-8859-1, utf-8;q=0.66, *;q=0.66
		Keep-Alive: 300
		Connection: keep-alive
		Content-type: multipart/form-data; boundary=---------------------------278722862861021530336465782
		Content-Length: 458

		-----------------------------278722862861021530336465782
		Content-Disposition: form-data; name="blah"; filename="ditech.txt"
		Content-Type: text/plain


		30 yr
		fixed rate
		$126,600
		6.75
		$821 / mo
		$3095 closing costs ($180 discount for including tax/ins.) + 1.5 ($1899) = $4994


		30 yr 
		fixed
		$132,000
		6.75
		$856 / mo
		0 out of pocket


		Aaron Rasmussen
		Fax
		(714) 800 7171
		Voice
		800 713 4933 x6171



		-----------------------------278722862861021530336465782--



*/


#include <stdarg.h>
#include <string.h>
#include <signal.h>

#ifndef WIN32
#include <pwd.h>
#endif

#include "system.cpp"
#include "thread.cpp"
#include "mutex.cpp"
#include "object.cpp"
#include "queue.cpp"
#ifdef SSLSERVER
#include "../SSLServerSocket.cpp"
#else
#include "serversocket.cpp"
#endif
#include "urlencode.cpp"
#include "str.cpp"
#include "log.cpp"
#include "file.cpp"





static void mthttpd_sighandler(int s)
{
	fprintf(stdout, "ALERT: CAUGHT SIGNAL %d\n", s);
	exit(1);
}


struct Transaction 
{
	Socket *sock;

	char line[4096];
	char method[32];
	char path[5000];
	unsigned long contentLength;
	char contentType[5000];
	char boundary[5000];
	char query[5000];
#define MAX_QUERY_ARGS	100
	int  queryArgs;
	char *queryTags[MAX_QUERY_ARGS];
	char *queryVals[MAX_QUERY_ARGS];


	/* These are shadows of what are in the server object.
	The server copies it's values into the transaction before calling
	transact(), then copies these back out into it's own vars after transact()
	returns.  This is how the Transaction causes the server to exit/abort.
	XXX this is bogus and I'm pretty sure it doesn't work cause it's not
	really thread-synced */
	int running;
	int aborted;


	/* This is just data that the daemon crams in here so
	that the 'hstatus' message can have some information to display.
	It gets stuffed in before each call to transact(). */
	const char *title;			// Server name
	int port;					// Port number server is listening on
	int totalHits;				// Total hits server has received
	float perMinHits;			// Current average rate of pummeling
	const char *started;		// Date and time server was started
	int numThreads;
	int numIdle;
	int numStalled;


	Transaction()
	{
		title = "Unknown";
		port = 0;
		totalHits = 0;
		perMinHits = 0;
		started = "Unknown";
		running = 1;
		aborted = 0;
	}

	virtual ~Transaction()
	{
	}

	void setServerInfo(const char *t, int p, int th, float pmh, const char *s, int nt, int ni, int ns)
	{
		title = t;
		port = p;
		totalHits = th;
		perMinHits = pmh;
		started = s;
		numThreads = nt;
		numIdle = ni;
		numStalled = ns;
	}


	virtual void transact(int id, Socket *s)
	{
		sock = s;

		int r;

		// Read the first line
		r = sock->readLine(line, sizeof(line));
		if(r < 1)
		{
			respond404();
			return;
		}
TRACE("first line: '%s'\n", line);

		r = sscanf(line, "%15s %4095[^ ] %*[^\n]\n", method, path);
		if(r != 2)
		{
			respond404();
			return;
		}
		method[sizeof(method) - 1] = 0;
		path[sizeof(path) - 1] = 0;
TRACE("method = '%s'\n", method);
TRACE("path = '%s'\n", path);
	

		/* Parse the args from the query string (if present) and store them
		into queryTags[] and queryVals[] */
		queryArgs = 0;
		char *q = strchr(path, '?');
		if(q)
		{
			// We have a query string!  Oh joy!
			*q = 0;				// terminate path str
			q++;				// skip the '?' char
			if(*q != 0)
			{
				// Make a copy of entire query string
				Str::copy(query, q, sizeof(query));
TRACE("query string: '%s'\n", query);

				// Break it up on '&' chars.
				while(queryArgs < MAX_QUERY_ARGS)
				{
					queryTags[queryArgs++] = q;
					q = strchr(q, '&');
					if(!q)
						break;
					*q = 0;
					q++;
				}

				// Break tag/val pairs (in queryTags currently) up on '=' chars.
				int i;
				char *t;
				char *v;
				for(i = 0; i < queryArgs; i++)
				{
					t = queryTags[i];
					v = strchr(t, '=');
					if(v)
					{
						*v++ = 0;				// terminate tag
						queryVals[i] = v;		// note val
					}
					else
					{
						queryVals[i] = t + strlen(t);	// make val an empty str
					}
				}

				// Now urldecode the tags and vals
				for(i = 0; i < queryArgs; i++)
				{
					URLEncode::decode(queryTags[i], queryTags[i]);
					URLEncode::decode(queryVals[i], queryVals[i]);
TRACE("param[%d]: '%s'='%s'\n", i, queryTags[i], queryVals[i]);
				}
			}

		}


		// Decode the path string
		URLEncode::decode(path, path);



		// emasculate mischievous paths
		if(strstr(path, "../"))
		{
			/* Any occurance of "../" anywhere in the path is
			grounds for dismissal. */
			respond404();
			return;
		}
		while(Str::startsWith(path, "/"))
		{
			/* If the path has a "/" at the beginning, remove it.
			Note that i do this in a while loop, in case it starts
			with "////" or something evil like that. */
			strcpy(path, path+1);
		}


		// Read all the header lines
		contentLength = 0;
		contentType[0] = 0;
		boundary[0] = 0;
		while(true)
		{
			r = sock->readLine(line, sizeof(line));
			if(r < 1)
			{
				// Doh!
				respond404();
				return;
			}
			if(line[0] == '\n')
				break;			// blank line signals end of header lines
TRACE("header: %s", line);

			/* Hit the line with a series of sscanf()s, those that
			match the input will make a conversion.  Those that don't,
			won't ... no harm done. */
			sscanf(line, "%*[cC]ontent-%*[lL]ength: %lu\n", &contentLength);
			sscanf(line, "%*[cC]ontent-%*[tT]ype: %[^;\n]\n", contentType);
			sscanf(line, "%*[cC]ontent-%*[tT]ype: %*[^;]; boundary=%[^;\n]\n", boundary);

		}
TRACE("contentLength = %lu\n", contentLength);
TRACE("contentType = %s\n", contentType);
TRACE("boundary = %s\n", boundary);

TRACE("calling respond() ...\n");
		respond();
TRACE("respond() returned, transaction complete\n");

	}


	// ----------------------------------------------------------------
	

	/* Fetch the value for a query item given it's tag.
	The tag comparison is case-insensitive.
	Returns null if the tag isn't found. */
	char *getQueryItem(const char *tag)
	{
		char *val = 0;
		for(int i = 0; i < queryArgs; i++)
		{
			if(Str::equals(queryTags[i], tag))
				return queryVals[i];
		}
		return val;
	}


	/* Like getQueryItem() except that it never returns NULL.
	If the item wasn't sent, it returns "". */
	char *item(const char *tag)
	{
		char *s = getQueryItem(tag);
		if(!s)
			s = "";
		return s;
	}

	/* Like item() but returns the value as an integer */
	int itemInt(const char *tag)
	{
		return atoi(item(tag));
	}


	// ---------------------------------------------------------------
	

	/* This is the MAIN response method and should normally be overridden
	by subclasses to do something special. */
	virtual void respond()
	{
		if(Str::startsWith(path, "control"))
		{
			respondControl();
			return;
		}

		respondFile();
	}


	/* Server control respond function */
	virtual void respondControl()
	{
		const char *action = item("action");
		if(Str::equals(action, "traceon"))
		{
			TRACEON();
			DTLOG("TRACE MODE ON\n");
			respond200Text(
					"Tracing turned ON\n\n"
					"WARNING:\n"
					"   Trace mode generates lots of text in the log, and server\n"
					"   performance will suffer greatly.  Tracing should not\n"
					"   normally be left on for any length of time.\n"
					);
		}
		else
		if(Str::equals(action, "traceoff"))
		{
			TRACEOFF();
			DTLOG("TRACE MODE OFF\n");
			respond200Text("Tracing turned OFF\n");
		}
		else
		if(Str::equals(action, "exit"))
		{
			respond200Text(
					"Server exiting.\n"
					//"It may not fully exit immediately as there could be\n"
					//"transactions in progress.  It should be stopped\n"
					//"within 60 seconds or so.\n"
					//"It will NOT restart.\n"
					);
			DTLOG("Server exiting\n");
#ifndef WIN32
			exit(0);
#endif
			// XXX
			running = 0;
			aborted = 0;
		}
		else
		if(Str::equals(action, "abort"))
		{
			respond200Text(
					"Server aborted.\n"
					//"It should restart automatically within a few seconds.\n"
					);
			// XXX
			// This is a tad scary, but I think it's what I want.
			// I was just setting a flag and then trying to let my
			// threads fall out, join up, etc., then return a different
			// error code.
			// However, when I had threads that were hung up, the server
			// wouldn't actually fall out right away.
			// This, however, should actually just bust it down quick
			// and return the error code I want.
			DTLOG("Server aborted\n");
#ifndef WIN32
			exit(1);
#endif
			// XXX
			running = 0;
			aborted = 1;
		}
		else
		if(Str::equals(action, "hstatus"))
		{
			sock->writeStr("HTTP/1.0 200 OK\n");
			sock->writeStr("Content-Type: text/html\n");
			sock->writeStr("\n");
			sock->writeStr("<html><head><meta http-equiv='refresh' content='900'><title>Server Statistics</title></head><body bgcolor=#aaffaa>");

			sock->writeStr("<table border=0 width=100%>");
			sock->writeStr("<tr bgcolor=#99ee99>");
			sock->writeStr("<td><font face=helvetica size=-2><b>Server</b></td>");
			sock->writeStr("<td><font face=helvetica size=-2><b>Version</b></td>");
			sock->writeStr("<td><font face=helvetica size=-2><b>Port</b></td>");
			sock->writeStr("<td><font face=helvetica size=-2><b>Threads/Idle/Stalled</b></td>");
			sock->writeStr("<td><font face=helvetica size=-2><b>Started</b></td>");
			sock->writeStr("<td><font face=helvetica size=-2><b>Total Hits</b></td>");
			sock->writeStr("<td><font face=helvetica size=-2><b>Hits/min</b></td>");
			sock->writeStr("</tr>");

			sock->writeStr("<tr>");
			sock->writeStr("<td><font face=helvetica size=-2>"); sock->writeStr(title); sock->writeStr("</td>");

#ifndef VER_STR
#define VER_STR "Unknown"
#endif
			sock->writeStr("<td><font face=helvetica size=-2>");
			sock->writeStr(VER_STR);
#ifdef SSLSERVER
			sock->writeStr(" <b> (SECURE) </b>");
#endif
			sock->writeStr("</td>");


			sock->writeStr("<td><font face=helvetica size=-2>"); sock->writeInt(port); sock->writeStr("</td>");
			sock->writeStr("<td><font face=helvetica size=-2>");
				sock->writeInt(numThreads);
				sock->writeStr(" / ");
				sock->writeInt(numIdle);
				sock->writeStr(" / ");
				sock->writeInt(numStalled);
				sock->writeStr("</td>");
			sock->writeStr("<td><font face=helvetica size=-2>"); sock->writeStr(started); sock->writeStr("</td>");
			sock->writeStr("<td><font face=helvetica size=-2>"); sock->writeInt(totalHits); sock->writeStr("</td>");
			sock->writeStr("<td><font face=helvetica size=-2>"); sock->writeFloat(perMinHits); sock->writeStr("</td>");
//DTLOG("started='%s'\n", started);
			sock->writeStr("</tr>");

			sock->writeStr("</table>");

			sock->writeStr("</body></html>");
		}
		else
		{
			respond200Text("Unrecognized action.");
		}
	}


	// Respond with a simple plain text msg.
	virtual void respond200Text(const char *msg)
	{
		sock->writeStr("HTTP/1.0 200 OK\n");
		sock->writeStr("Content-Type: text/plain\n");
		sock->writeStr("Content-Length: ");
			sock->writeInt((int)strlen(msg));
			sock->writeStr("\n");
		sock->writeStr("\n");
		sock->writeStr(msg);
	}


	virtual void respond404()
	{
		sock->writeStr("HTTP/1.0 404\n");
		sock->writeStr("Content-Type: text/html\n");
		sock->writeStr("\n");
		sock->writeStr("<html><head><title>Document Not Found</title></head>\n");
		sock->writeStr("<body>Document not found on this server.</body>\n");
	}


	virtual void respondFile()
	{
		
		/* Check for a lack of a path, or directory path and
		add "/index.html" if needed. */
		int pl = strlen(path);
		if(path[0] == 0)
			strcpy(path, "index.html");
		else
		if(path[pl - 1] == '/')
			path[pl - 1] = 0;
		File pf(path);
		if(pf.isDir())
			strcat(path, "/index.html");


		// XXX
		// possibly return dir listings (if no index.html) in a separate
		// function respondDir() which can be overridden.
		// XXX


		// Figure out the length of the file.
		FILE *fp = fopen(path, "rb");
		if(!fp)
		{
			respond404();
			return;
		}
		if(fseek(fp, 0, SEEK_END) == -1)
		{
			fclose(fp);
			respond404();
			return;
		}
		int len = ftell(fp);
		if(len == -1)
		{
			fclose(fp);
			respond404();
			return;
		}
		if(fseek(fp, 0, SEEK_SET) == -1)
		{
			fclose(fp);
			respond404();
			return;
		}

		sock->writeStr("HTTP/1.0 200 OK\n");


		// Send a content-type header for things we know about.
		if(Str::endsWith(path, ".html"))
			sock->writeStr("Content-Type: text/html\n");
		else
		if(Str::endsWith(path, ".txt"))
			sock->writeStr("Content-Type: text/plain\n");
		else
		if(Str::endsWith(path, ".jpg"))
			sock->writeStr("Content-Type: image/jpeg\n");
		else
		if(Str::endsWith(path, ".bmp"))
			sock->writeStr("Content-Type: image/bmp\n");
		else
		if(Str::endsWith(path, ".jpeg"))
			sock->writeStr("Content-Type: image/jpeg\n");
		else
		if(Str::endsWith(path, ".gif"))
			sock->writeStr("Content-Type: image/gif\n");
		else
		if(Str::endsWith(path, ".js"))
			sock->writeStr("Content-Type: application/x-javascript\n");

		// Include length of file data
		sock->writeStr("Content-Length: ");
			sock->writeInt(len);
			sock->writeStr("\n");

		if(Str::equals(method, "head"))
		{
			sock->writeStr("Last-Modified: ");
			struct stat buf;
			lstat(path, &buf );
			sock->writeStr(ctime(&buf.st_mtime));
		}


		// Terminate headers.
		sock->writeStr("\n");


		if(!Str::equals(method, "head"))
		{
			char buf[10 * 1024];
			int left = len;
			int n;
			int r;
			int w;
			while(left > 0)
			{
				n = sizeof(buf);
				if(left < n)
					n = left;
				r = fread(buf, 1, n, fp);
				if(r == n)
				{
					w = sock->write(buf, r);
					if(w == r)
					{
						left -= w;
						continue;
					}
				}
				break;
			}
		}
		
		
		fclose(fp);
	}

};


struct MTHTTPDaemon : Runnable
{
	int port;
	int backlog;
	int running;
	int aborted;

	int totalHits;
	float perSecHits;		// average hits per second
	float perMinHits;		// average hits per minute
	int hits;
	unsigned long tLast;

	char *title;			// Server's title or name
	char started[100];		// ASCII string, time/date server was started

	int numThreads;
	Thread **threads;
	bool *thIdle;
	bool *thStalled;
	unsigned long *thWoke;
	int numIdle;
	int numStalled;
	int threadID;
	Object threadGate;
	Mutex jobSync;
	Queue jobs;
	

	/* These are only used in the SSL version of the server which is
		only built when SSLSERVER is defined. */
	const char *randfile;
	const char *certfile;
	const char *keyfile;


	void init(int p, int bl, int nt, const char *rf, const char *cf, const char *kf)
	{
		port = p;
		backlog = bl;
		running = 0;
		aborted = 0;
		totalHits = 0;
		perSecHits = 0;
		perMinHits = 0;
		hits = 0;
		tLast = System::currentTimeMillis();
		time_t tt = time(0);
		strftime(started, sizeof(started), "%d/%b/%Y %H:%M:%S %z", localtime(&tt));
		title = "MTHTTPDaemon";


		// Initialize threads and associated data
		numThreads = nt;
		threads = new Thread *[numThreads];
		thIdle = new bool[numThreads];
		thStalled = new bool[numThreads];
		thWoke = new unsigned long[numThreads];
		unsigned long tNow = System::currentTimeMillis();
		for(int i = 0; i < numThreads; i++)
		{
			threads[i] = new Thread(this);
			thIdle[i] = false;
			thStalled[i] = false;
			thWoke[i] = tNow;
		}
		threadID = 0;


		randfile = rf;
		certfile = cf;
		keyfile = kf;


#ifndef WIN32
		signal(SIGHUP, mthttpd_sighandler);
//		signal(SIGINT, mthttpd_sighandler);
		signal(SIGQUIT, mthttpd_sighandler);
		signal(SIGILL, mthttpd_sighandler);
		signal(SIGABRT, mthttpd_sighandler);
		signal(SIGFPE, mthttpd_sighandler);
		signal(SIGSEGV, mthttpd_sighandler);
		signal(SIGPIPE, mthttpd_sighandler);
		signal(SIGALRM, mthttpd_sighandler);
		signal(SIGTERM, mthttpd_sighandler);
		signal(SIGUSR1, mthttpd_sighandler);
		signal(SIGUSR2, mthttpd_sighandler);
//		signal(SIGTSTP, mthttpd_sighandler);	// ^Z
		signal(SIGTTIN, mthttpd_sighandler);
		signal(SIGTTOU, mthttpd_sighandler);
		//
		signal(SIGBUS, mthttpd_sighandler);
		//signal(SIGPOLL, mthttpd_sighandler);
		signal(SIGPROF, mthttpd_sighandler);
		signal(SIGSYS, mthttpd_sighandler);
		signal(SIGTRAP, mthttpd_sighandler);
		signal(SIGVTALRM, mthttpd_sighandler);
		signal(SIGXCPU, mthttpd_sighandler);
		signal(SIGXFSZ, mthttpd_sighandler);
		//
		signal(SIGIOT, mthttpd_sighandler);
		//signal(SIGSTKFLT, mthttpd_sighandler);
		signal(SIGIO, mthttpd_sighandler);
		//signal(SIGPWR, mthttpd_sighandler);
		//signal(SIGLOST, mthttpd_sighandler);
		//signal(SIGUNUSED, mthttpd_sighandler);
#endif

	}


	virtual ~MTHTTPDaemon()
	{
		if(threads)
		{
			for(int i = 0; i < numThreads; i++)
			{
				if(threads[i])
					delete threads[i];
			}
			delete threads;
		}
	}


	int start()
	{
		DTLOG("%s started\n", title);

#ifdef SSLSERVER
		SSLServerSocket ss(port, backlog, randfile, certfile, keyfile);
#else
		ServerSocket ss(port, backlog);
#endif

#ifndef WIN32
		uid_t uid = 2;	// uid of 2 is hopefully "daemon"
		struct passwd *p = getpwnam("apache");
		if(p)
			uid = p->pw_uid;
		setuid(uid);
#endif	

		if(!ss.isListening())
		{
			DTLOG("ALERT: Can't create ServerSocket on port %d\n", port);
			return 1;
		}

		running = 1;

		// Start all transactor threads running.
TRACE("starting %d threads\n", numThreads);
		int i;
		for(i = 0; i < numThreads; i++)
			threads[i]->start();

		DTLOG("%s listening on port %d\n", title, port);
		while(running)
		{
//TRACE("sleeping for connection (zzzz) ...\n");
			Socket *sock = ss.accept();
			if(sock != NULL)
			{
				totalHits++;
TRACE("hit from %s\n", sock->remoteIP);


				// Add up number of idle threads for display in the status page
				numIdle = 0;
				numStalled = 0;
				int i;
				for(i = 0; i < numThreads; i++)
				{
					if(thIdle[i])
					{
						// This means the thread is sleeping
						numIdle++;
					}
					else
					{
						// This means the thread is awake.
						// It will have set thWoke[n] right after waking up
						if((System::currentTimeMillis() - thWoke[i]) >= 15000)
						{
							thStalled[i] = true;
							numStalled++;
						}
					}
				}
//TRACE("numThreads: %d  Idle: %d  Stalled: %d\n", numThreads, numIdle, numStalled);

				// Put the socket on the jobs queue
				//jobSync.lock();
				jobs.queue(sock);
				int j = jobs.length();
				//jobSync.unlock();
//TRACE("jobs.length: %d\n", jobs.length());


				// Wake up a thread(s) to handle the job(s).
				for(i = 0; i < j; i++)
					threadGate.notify();

//TRACE("tickled %d threads\n", j);

				// Compute hits per second
				hits++;
				unsigned long tNow = System::currentTimeMillis();
				unsigned long tElapsed = tNow - tLast;
				if(tElapsed >= (60 * 1000))
				{
					perSecHits = (float)((hits * 1000) / tElapsed);
					perMinHits = (float)((hits * (60 * 1000)) / tElapsed);
					tLast = tNow;
					hits = 0;
				}
//TRACE("total hits: %d\n", hits);
//TRACE("hits per sec: %d\n", perSecHits);
//TRACE("hits per min: %d\n", perMinHits);
			}
			else
			{
				DTLOG("ALERT: Bad accept()\n");
			}

		}
TRACE("main loop exited\n");


		/* wake up any and all sleeping transactor
			threads and join up with them before returning. */
#ifdef WIN32
		for(i = 0; i < numThreads; i++)
		{
			threadGate.notify();
			threads[i]->join();
		}
#else
		threadGate.notifyAll();
		for(i = 0; i < numThreads; i++)
		{
			threads[i]->join();
		}
#endif

		return aborted ? 1 : 0;
	}


	/* This is normally overridden to return your own subclass
		of Transaction which does your own specific type of stuff. */
	virtual Transaction *createTransaction()
	{
		return new Transaction();
	}


	/* This is entry point for all transaction handling threads.  */
	void run()
	{
		// Get my thread id # synchronously
		jobSync.lock();
		int id = threadID++;
		jobSync.unlock();

		Transaction *t = createTransaction();
		if(!t)
		{
TRACE("Unable to create Transaction object\n");
			aborted = 1; 
			running = 0;
			return;
		}

TRACE("thread %d running\n", id);
		while(running)
		{

			// Get next job from jobs queue if there is one.
			//jobSync.lock();
			Socket *sock = (Socket *)jobs.next();
			//jobSync.unlock();
			if(sock)
			{
#ifndef WIN32
				/* Set the SO_KEEPALIVE flag.
				This (hopefully) prevents my threads from hanging.
				My theory being that the client sometimes vanishes (crashes,
				looses connection, etc.) but the server isn't aware of it
				and sits blocking in a read or write operation. */
				int ka;
				socklen_t kas = sizeof(ka);
				if(int r = setsockopt(sock->sock, SOL_SOCKET, SO_KEEPALIVE, &ka, kas))
					SLOG("ALERT: setsockopt(SO_KEEPALIVE) failed %d\n", r);
#endif




TRACE("thread %d working on job from %s\n", id, sock->remoteIP);
//				if(t)		// XXX um ... any reason why this might not be true?
				{

					t->setServerInfo(title, port, totalHits, perMinHits, started, numThreads, numIdle, numStalled);

					// This is a hack
					t->running = running;
					t->aborted = aborted;

					t->transact(id, sock);			// Process the transaction

					// This is a more of the same hack.
					aborted += t->aborted;
					if(!t->running)
						running -= running;

				}
				delete sock;					// Close the connection.
			}

			// Wait to be notified of more work to do.
			if(running)
			{
TRACE("thread %d sleeping\n", id);
				thIdle[id] = true;
				threadGate.wait();
				thWoke[id] = System::currentTimeMillis();
				thIdle[id] = false;
TRACE("thread %d woke up\n", id);
			}
		}


#ifdef WIN32
		System::msleep(200);
		exit(aborted);
#endif

		delete t;
TRACE("thread %d exiting\n", id);
	}

};


#ifdef TEST_MTHTTPD

#include <stdio.h>
#include <stdlib.h>

int main(int argc, char **argv)
{
	MTHTTPDaemon httpd;

#ifdef SSLSERVER

	if(argc < 5)
	{
		printf("Usage: %s port randfile certfile keyfile\n", argv[0]);
		return 1;
	}

	httpd.init(atol(argv[1]), 10, 4, argv[2], argv[3], argv[4]);

#else

	if(argc < 2)
	{
		printf("Usage: %s port\n", argv[0]);
		return 1;
	}

	httpd.init(atol(argv[1]), 10, 4, ".", ".", ".");

#endif

	return httpd.start();
}


#if 0
#ifdef WIN32

#include "gui.cpp"

#include "httpsimple.cpp"


static int listenPort = 80;


struct MyDisplay : WDisplay
{
	Image *imgBG;

	MyDisplay(const char *t, int _w, int _h, int fs) : WDisplay(t, _w, _h, fs)
	{
		imgBG = new Image("mthttpdbg.bmp");
	}

	void paint()
	{
		backBuf->fillRect(0, 0, width, height, 0x000000, 1.0f);
		if(imgBG)
			backBuf->blit(imgBG, 0, 0, 1.0f, 0);
		WDisplay::paint();
	}

	void close()
	{
		char buf[256];
		int r = httpGetSimple("localhost", listenPort, "/control?action=exit", buf, sizeof(buf));
		if(r >= 0)
			buf[r] = 0;
		System::msleep(500);
		WDisplay::close();

	}
};


static void *worker(void *)
{
	char *av[2] = { "mthttpd", "80" };
	main(2, av);
	return 0;
}


int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	MyDisplay display("MTHTTPD", 260, 100, 0);

	Thread thread(worker);
	thread.start(0);

	display.show();
	while(!display.quit)
	{
		display.waitEvent();
		display.dispatch();
	}

	Thread::join(&thread);

	Sleep(250);

	return 0;
}

#endif
#endif


#endif




#endif	// com_sleepless_mthttpd_cpp

