#if 0

Anyway, see sha1.cpp for a SHA1 class.

This one is now effectively defunct.
I think Bryan Ford wrote this one, but it wasn't set up to handle unlimited length
streams, which I needed.  I start hacking away at it, but decided to just go find one
instead of trying to modify it.
I also suspect it wouldn't have worked for messages over 64 bytes in length.

j.h.


#ifndef com_sleepless_sha_cpp
#define com_sleepless_sha_cpp


#include <stdio.h>
#include <string.h>


struct SHA
{
	typedef struct sha_digest { unsigned long A, B, C, D, E; } sha_digest;

	typedef unsigned char u8;
	typedef unsigned long u32;
#ifdef WIN32
	typedef __int64 u64;
#else
	typedef unsigned long long u64;
#endif


	sha_digest digest;
	u64 message_size;
	u32 digA, digB, digC, digD, digE;
	char ascii[41];

	void start()
	{
		message_size = (u64)0; //size * 8;
		digA = 0x67452301;
		digB = 0xEFCDAB89;
		digC = 0x98BADCFE;
		digD = 0x10325476;
		digE = 0xC3D2E1F0;
	}

	void finish()
	{



		// Return the final message digest. 
		digest.A = digA;
		digest.B = digB;
		digest.C = digC;
		digest.D = digD;
		digest.E = digE;
		sprintf(ascii, "%8.8lx%8.8lx%8.8lx%8.8lx%8.8lx", digest.A, digest.B, digest.C, digest.D, digest.E);
	}

	void update(const void *message, long size)
	{
		/* Loop through each 512-bit block of the message.  */
		while (1)
		{
			u32 A = digA;
			u32 B = digB;
			u32 C = digC;
			u32 D = digD;
			u32 E = digE;
			u32 W[80];
			u32 t;
			u32 nA;

			/* Find the contents of this block, in the first 16 words of W[].  */
			if (size >= 512/8)
			{
				/* Supply the complete block straight from the message. */
				memcpy(W, message, 512/8);
			}
			else if (size >= (512-64)/8)
			{
				/* This is the last block of the message, but there's not enough room for at
				   least one pad bit and the u64 holding the message length.  Just place the
				   necessary padding in this block. There will be one final block afterwards. */
				memcpy(W, message, size);
				((u8*)W)[size] = 0x80;
				memset((u8*)W+size+1, 0, 512/8-(size+1));
			}
			else if (size >= 0)
			{
				/* This is the last block of the message,
				   and there _is_ room for the padding and length.  */
				if (size > 0)
					memcpy(W, message, size);
				((u8*)W)[size] = 0x80;
				memset((u8*)W+size+1, 0, (512-64)/8-(size+1));
				*(u64*)(W+(512-64)/32) = message_size;
			}
			else if (size >= -64/8)
			{
				/* This is a trailer block, holding no part of the message,
				   only padding and the message size.  */
				memset(W, 0, (512-64)/8);
				*(u64*)(W+(512-64)/32) = message_size;
			}
			else
			{
				/* We're done.  */
				break;
			}
			size -= 512/8;

			/* Generate the remaining four of the first 20 values of W_t. */
			for (t = 16; t < 20; t++)
				W[t] = W[t-16] ^ W[t-14] ^ W[t-8] ^ W[t-3];

			/* Run the digest buffer through the rounds. */
			for (t = 0; t < 20; t++)
			{
				nA = ((A << 5) | (A >> 27))
					+ ((B & C) | (~B & D))
					+ E
					+ W[t]
					+ 0x5A827999;
				E = D;
				D = C;
				C = ((B << 30) | (B >> 2));
				B = A;
				A = nA;
			}
			for (; t < 40; t++)
			{
				W[t] = W[t-16] ^ W[t-14] ^ W[t-8] ^ W[t-3];
				nA = ((A << 5) | (A >> 27))
					+ (B ^ C ^ D)
					+ E
					+ W[t]
					+ 0x6ED9EBA1;
				E = D;
				D = C;
				C = ((B << 30) | (B >> 2));
				B = A;
				A = nA;
			}
			for (; t < 60; t++)
			{
				W[t] = W[t-16] ^ W[t-14] ^ W[t-8] ^ W[t-3];
				nA = ((A << 5) | (A >> 27))
					+ ((B & C) | (B & D) | (C & D))
					+ E
					+ W[t]
					+ 0x8F1BBCDC;
				E = D;
				D = C;
				C = ((B << 30) | (B >> 2));
				B = A;
				A = nA;
			}
			for (; t < 80; t++)
			{
				W[t] = W[t-16] ^ W[t-14] ^ W[t-8] ^ W[t-3];
				nA = ((A << 5) | (A >> 27))
					+ (B ^ C ^ D)
					+ E
					+ W[t]
					+ 0xCA62C1D6;
				E = D;
				D = C;
				C = ((B << 30) | (B >> 2));
				B = A;
				A = nA;
			}

			/* Add final digest buffer back into the overall digest. */
			digA += A;
			digB += B;
			digC += C;
			digD += D;
			digE += E;
		}
	}

	SHA()
	{
		start();
	}

	SHA(const char *path)
	{
		start();
		char buf[518/4];
		FILE *fp = fopen(path, "rb");
		int n;
		if(fp)
		{
			// hash the contents of a file
			n = fread(buf, 1, sizeof(buf), fp);
			if(n == 0)
				break;
			update(buf, n);
			fclose(fp);
		}
		finish();
	}

	SHA(const char *buf, int len)
	{
		start();
		update(buf, len);
		finish();
	}
};



#ifdef SHA_TEST

#include <stdlib.h>

int main(int argc, char **argv)
{
	FILE *stream = stdin;

	if(argc > 1)
	{
		stream = fopen(argv[1], "rb");	
		if(!stream)
		{
			// just hash the argument string
			SHA sha(argv[1], strlen(argv[1]));
			puts(sha.ascii());
			exit(0);
		}
	}

	SHA sha;
	sha.start();

	char buf[512/8];
	while(true)
	{
		if(ferror(stream))
		{
			perror();
			exit(1);
		}
		int r = fread(buf, 1, sizeof(buf), stream);
		if(r == 0)
			break;
		sha.update(buf, r);
	}

	sha.finish();
	puts(sha.ascii());

	exit(0);
}

#endif



#endif		// com_sleepless_sha_cpp
#endif
