/*
Copyright 2011 Sleepless Software Inc. All rights reserved.

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to
deal in the Software without restriction, including without limitation the
rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
sell copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
IN THE SOFTWARE. 
*/

if((typeof process) == 'undefined') {
	isNode = !(isPage = true)
}
else {
	isPage = !(isNode = true)
}


function o2j(o) { return JSON.stringify(o) }
function j2o(j) { try { return JSON.parse(j) } catch(e) { } return null }
function millis() { return new Date().getTime() }
function time() { return Math.floor(millis() / 1000) }
function pint(n) { return parseInt(n) || 0 }
function pflt(n) { return parseFloat(n) || 0 }


String.prototype.lower = function() { return this.toLowerCase() }
String.prototype.upper = function() { return this.toUpperCase() }
String.prototype.trim = String.prototype.trim || function() {
	return this.replace(/^\s+/gi, "").replace(/\s+$/gi, "")
}
String.prototype.abbr = String.prototype.abbr || function(l) {
	return this.length > l ? this.substring(0, l - 4)+" ..." : this
}
String.prototype.cap = String.prototype.cap || function() {
	return this.substring(0,1).toUpperCase() + this.substring(1)
}


Array.prototype.forEach = Array.prototype.forEach || function(cb) {
	var l = this.length, i
	for(i = 0; i < l; i++)
		cb(this[i], i)
}

Date.prototype.toUS = function(ts) {
	var d = this
	if(ts !== undefined)
		d = new Date(ts)
	var lz = function(s) { return ("0"+s).substr(-2) }
	return lz(d.getMonth()) + "/" + lz(d.getDate()) + "/" + lz(d.getYear())
}


// 1050 -> 10.50 
function toBucks(n) { return (pint(""+(n+0.5))/100).toFixed(2) }
// 10.50500 -> 1051 
function toCents(n) { return Math.floor((n + 0.005) * 100) }


function validEmail(s) {
	return /^[A-Za-z0-9_\+-]+(\.[A-Za-z0-9_\+-]+)*@[A-Za-z0-9-]+(\.[A-Za-z0-9-]+)*\.([A-Za-z]{2,4})$/.test(s)
}


if(isPage) {

	function elem(id) { return document.getElementById(id) }

	function dbg(s) {
		var e = elem('dbg')
		if(s === true || s === false) {
			dbg.onoff = s
			if(e)
				document.body.removeChild(e)
		}
		else {
			s = ""+s
			if(dbg.onoff) {
				e = elem('dbg')
				if(!e) {
					e = mkDiv()
					e.id = 'dbg'
					e.style.padding = "0.5em 1em"
					e.style.backgroundColor = "#fcc"
					e.style.color = "#800"
					e.style.border = "dotted 2px #800"
					e.style.fontFamily = "courier"
					e.style.fontSize = "80%"
					e.style.position = "fixed"
					e.style.right = 0
					e.style.bottom = 0
					e.style.opacity = 0.8
					e.ondblclick = function() {e.innerHTML = ""}
					document.body.appendChild(e)
				}
				e.appendChild(mkDiv(s))
			}
		}
	}
}

