<? /* Copyright 2008 Sleepless Software Inc.  All Rights Reserved */


class Table2
{

	var $cls;
	var $rows = array();
	var $clses = array();
	var $currow;
	var $curcol;
	var $stack;
	var $tid;

	function Table2($s = "", $tid = "")
	{
		if($tid == "")
			$tid = $s;
		$this->tid = $tid;
		$this->stack = array();
		$this->currow = 0;
		$this->curcol = 0;
		$this->cls = $s;
		$this->clses["t"] = $s."_table";
		$this->clses["h"] = $s."_head";
		$this->clses["c"] = $s."_cell";
	}

	
	function setclass($newid, $x = -1, $y = -1)
	{
		if($x == -1)
			$x = $this->curcol;
		if($y == -1)
			$y = $this->currow;
		$this->clses["$x:$y"] = $this->cls."_$newid";
	}
	function setid($newid, $x = -1, $y = -1) { $this->setclass($newid, $x, $y); }	// deprecated


	function setclassrow($newid, $y = -1)
	{
		if($y == -1)
			$y = $this->currow;
		$n = count($this->rows[$y]);
		for($i = 0; $i < $n; $i++)
			$this->setid($newid, $i, $y);
	}
	function setidrow($newid, $y = -1) { $this->setclassrow($newid, $y); } // deprecated

	function setclasscol($newid, $x = -1, $num = -1)
	{
		if($x == -1)
			$x = $this->curcol;
		$n = count($this->rows);
		if($num != -1 and $num < $n)
			$n = $num;
		for($i = 0; $i < $n; $i++)
			$this->setid($newid, $x, $i);
	}

	function row($n, $truncate = false)
	{
		while($truncate && (count($rows) > ($n + 1)))
			array_pop($rows);
		$this->currow = $n;
		$this->curcol = 0;
	}

	function nextrow()
	{
		$this->row(count($this->rows));
	}

	function rowtrunc($n)
	{
		while(count($this->rows) > $n)
			array_pop($this->rows);
		$this->nextrow();
	}

	function delrow($i)
	{
		$l = count($this->rows);
		if(($l > 0) and ($i >= 0) and ($i < $l))
		{
			$n = $l - $i;
			for($i = 0; $i < ($n - 1); $i++)
				$this->rows[$i] = $this->rows[$i + 1];
			unset($this->rows[$i]);
		}
	}

	function delcol($n)
	{
		$ly = count($this->rows);
		for($y = 0; $y < $ly; $y++)
		{
			$oldrow = $this->rows[$y];
			$newrow = array();
			$lx = count($oldrow);
			for($x = 0; $x < $lx; $x++)
			{
				$cell = array_shift($oldrow);
				if($x != $n)
					array_push($newrow, $cell);
			}
			$this->rows[$y] = $newrow;
		}
		if($this->currow >= $n)
			$this->currow--;
	}

	function col($n)
	{
		$this->curcol = $n;
	}

	function set($s, $x = -1, $y = -1, $cls = "cell")
	{
		if(is_string($x) && $y == -1 && $cls == "cell")
		{
			$cls = $x;
			$x = -1;
		}
		if(is_array($s))
		{
			foreach($s as $s2)
				$this->set($s2, $x, $y, $cls);
			return;
		}
		$s = trim($s);
		if($s == "")
			$s = "&nbsp;";
		if($x == -1)
			$x = $this->curcol;
		if($y == -1)
			$y = $this->currow;
		if(!isset($this->rows[$y]))
			$this->rows[$y] = array();
		$cols = &$this->rows[$y];
		for($i = 0; $i < $x; $i++)
		{
			if(!isset($cols[$i]))
				$cols[$i] = "&nbsp;";
		}
		$cols[$x] = $s;
		if($cls != "")
			$this->setclass($cls, $x, $y);
		$this->curcol = $x + 1;
		$this->currow = $y;
	}

	function setrow($s, $x = -1, $y = -1, $id = "")
	{
		$this->set($s, $x, $y, $id);
		$this->nextrow();
	}

	function getcols()
	{
	}

	function setoob($s, $x = -1, $y = -1, $cls = "cell")
	{
//fdbg("s=$s x=$x y=$y cls=$cls");
		$tc = $this->curcol;
		$tr = $this->currow;
		$this->set($s, $x, $y, $cls);
		$this->currow = $tr;
		$this->curcol = $tc;
	}

	function seth($s, $x = -1, $y = -1)
	{
		$this->set($s, $x, $y, "head");
	}

	function setspan($n, $s, $x = -1, $y = -1, $cls = "")
	{
		while($n-- > 1)
			$this->set("==SPAN==");
		$this->set($s, $x, $y, $cls);
	}

	function dumpstr()
	{
		$tcls = $this->clses["t"];
		$hcls = $this->clses["h"];
		$ccls = $this->clses["c"];
		$yn = count($this->rows);
		if($yn <= 0)
			return null;
		$s = "<table id='".$this->tid."' cellspacing='0' cellpadding='0' border='0' class='$tcls'>\n";
		for($y = 0; $y < $yn; $y++)
		{
			$s .= "<tr>\n";
			$cols = &$this->rows[$y];
			$xn = count($cols);
			for($x = 0; $x < $xn; $x++)
			{
				$cls = isset($this->clses["$x:$y"]) ? $this->clses["$x:$y"] : null;
				if(!$cls)
					$cls = ($y == 0) ? $hcls : $ccls;
				$c = "&nbsp;";
				$span = 1;
				$spanstr = "";
				if(isset($cols[$x]))
				{
					$c = $cols[$x];
					while($c == "==SPAN==")
					{
						$c = $cols[$x++];
						$span++;
					}
					if($span > 1)
						$spanstr = "colspan='$span'";
					//$cls = $this->clses["$x:$y"];
				}
				$s .= "<td $spanstr class='$cls'>$c</td>\n";
			}
			$s .= "</tr>\n";
		}
		$s .= "</table>\n";
		return $s;
	}

	function dump()
	{
		$s = $this->dumpstr();
		if($s)
			echo $s;
	}

}

/*
class Table
{

	var $id;
	var $rows = array();
	var $ids = array();
	var $currow;
	var $curcol;

	function Table($s = "")
	{
		$this->currow = 0;
		$this->curcol = 0;
		$this->id = $s;
		$this->ids["t"] = $s."_table";
		$this->ids["h"] = $s."_head";
		$this->ids["c"] = $s."_cell";
	}

	
	function setid($newid, $x = -1, $y = -1)
	{
		if($x == -1)
			$x = $this->curcol;
		if($y == -1)
			$y = $this->currow;
		$this->ids["$x:$y"] = $this->id."_$newid";
	}

	function setidrow($newid, $y = -1)
	{
		if($y == -1)
			$y = $this->currow;
		$n = count($this->rows[$y]);
		for($i = 0; $i < $n; $i++)
			$this->setid($newid, $i, $y);
	}

	function row($n)
	{
		$this->currow = $n;
		$this->curcol = 0;
	}

	function nextrow()
	{
		$this->row(count($this->rows));
	}

	function col($n)
	{
		$this->curcol = $n;
	}

	function set($s, $x = -1, $y = -1, $id = "")
	{
		$s = trim($s);
		if(is_string($x) && $y == -1 && $id == "")
		{
			$id = $x;
			$x = -1;
		}
		if($s == "")
			$s = "&nbsp;";
		if($x == -1)
			$x = $this->curcol;
		if($y == -1)
			$y = $this->currow;
		if(!isset($this->rows[$y]))
			$this->rows[$y] = array();
		$cols = &$this->rows[$y];
		$cols[$x] = $s;
		if($id != "")
			$this->setid($id, $x, $y);
		$this->curcol++;
	}

	// deprecated
	function setlast($s, $x = -1, $y = -1, $id = "")
	{
		$this->set($s, $x, $y, $id);
		$this->nextrow();
	}

	function setrow($s, $x = -1, $y = -1, $id = "")
	{
		$this->set($s, $x, $y, $id);
		$this->nextrow();
	}

	function setspan($n, $s, $x = -1, $y = -1, $id = "")
	{
		while($n-- > 1)
			$this->set("==SPAN==");
		$this->set($s, $x, $y, $id);
	}

	function dumpstr()
	{
		$tid = $this->ids["t"];
		$hid = $this->ids["h"];
		$cid = $this->ids["c"];
		$yn = count($this->rows);
		if($yn <= 0)
			return null;
		$s = "<table cellspacing='0' cellpadding='0' border='0' id='$tid'>\n";
		for($y = 0; $y < $yn; $y++)
		{
			$s .= "<tr>\n";
			$cols = &$this->rows[$y];
			$xn = count($cols);
			for($x = 0; $x < $xn; $x++)
			{
				$id = $this->ids["$x:$y"];
				if(!$id)
					$id = ($y == 0) ? $hid : $cid;
				$c = "&nbsp;";
				$span = 1;
				$spanstr = "";
				if(isset($cols[$x]))
				{
					$c = $cols[$x];
					while($c == "==SPAN==")
					{
						$c = $cols[$x++];
						$span++;
					}
					if($span > 1)
						$spanstr = "colspan='$span'";
				}
				$s .= "<td $spanstr id=$id>$c</td>\n";
			}
			$s .= "</tr>\n";
		}
		$s .= "</table>\n";
		return $s;
	}

	function dump()
	{
		$s = $this->dumpstr();
		if($s)
			echo $s;
	}

}
*/

