#ifndef com_sleepless_win_windows_cpp
#define com_sleepless_win_windows_cpp

/*
#		include <shlobj.h>
		char appdir[MAX_PATH];
		ITEMIDLIST* pidl;
		HRESULT hRes = SHGetSpecialFolderLocation( NULL, CSIDL_APPDATA|CSIDL_FLAG_CREATE , &pidl );
		if(hRes==NOERROR) 
			SHGetPathFromIDList( pidl, appdir );
		else
			appdir[0] = 0;
*/

#ifndef _CRT_SECURE_NO_DEPRECATE
#define _CRT_SECURE_NO_DEPRECATE
#endif


#ifndef WIN32
#error "You can't include a bunch of windows shit in a non-windows prog, silly."
#endif

#include "windows.h"
#include "winreg.h"
#include <wininet.h>
#include <shlwapi.h>
#include <tlhelp32.h>

#include "shlobj.h"
#include "shellapi.h"

#include "misc.cpp"
#include "file.cpp"
#include "directory.cpp"
#include "str.cpp"
#include "string.cpp"

#ifdef __CYGWIN__
#include <unistd.h>
#endif

#define MB2WC(mb,wc) MultiByteToWideChar(CP_ACP, 0, mb, -1, wc, sizeof(wc));


struct Windows
{

#if 0
--------------------------------------------------
95  		1  	4  	0	  	950
95 SP1 		1 	4 	0 		> 950 && <= 1080
95 OSR2 	1 	4 	< 10 	> 1080
98 			1 	4 	10 		1998
98 SP1 		1 	4 	10 		>1998 && < 2183
98 SE 		1 	4 	10 		>= 2183
Me 			1 	4 	90 		3000
NT 3.51 	2 	3 	51 		1057
NT 4 		2 	4 	0 		1381
2000 		2 	5 	0 		2195
XP 			2 	5 	1 	 
CE 1.0 		3 	1 	0 	 
CE 2.0 		3 	2 	0 	 
CE 2.1 		3 	2 	1 	 
CE 3.0 		3 	3 	0 	 
--------------------------------------------------
#endif
	static const char *getWindowsVersion(char *windows_version)
	{
		strcpy(windows_version, "Unknown");

		OSVERSIONINFOEX osvi;
		BOOL bOsVersionInfoEx;

		ZeroMemory(&osvi, sizeof(OSVERSIONINFOEX));
		osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFOEX);

		if( !(bOsVersionInfoEx = GetVersionEx ((OSVERSIONINFO *) &osvi)) )
		{
			osvi.dwOSVersionInfoSize = sizeof (OSVERSIONINFO);
			if (! GetVersionEx ( (OSVERSIONINFO *) &osvi) ) 
				return windows_version;
		}


		switch (osvi.dwPlatformId)
		{
		case VER_PLATFORM_WIN32_NT:
			if ( osvi.dwMajorVersion == 6 && osvi.dwMinorVersion == 0 )
			{
				strcpy(windows_version, "Vista");
			}
			else
			if ( osvi.dwMajorVersion == 5 && osvi.dwMinorVersion == 2 )
			{
				strcpy(windows_version, "XP Pro x64 / Server 2003 / Server 2003 R2");
			}
			else
			if ( osvi.dwMajorVersion == 5 && osvi.dwMinorVersion == 1 )
			{
				strcpy(windows_version, "XP");
			}
			else
			if ( osvi.dwMajorVersion == 5 && osvi.dwMinorVersion == 0 )
			{
				strcpy(windows_version, "2000");
			}
			else
			if ( osvi.dwMajorVersion <= 4 )
			{
				strcpy(windows_version, "NT");
			}
			break;

		case VER_PLATFORM_WIN32_WINDOWS:
			if (osvi.dwMajorVersion == 4 && osvi.dwMinorVersion == 0)
			{
				strcpy(windows_version, "95");
			} 
			else
			if (osvi.dwMajorVersion == 4 && osvi.dwMinorVersion == 10)
			{
				strcpy(windows_version, "98");
			} 
			else
			if (osvi.dwMajorVersion == 4 && osvi.dwMinorVersion == 90)
			{
				strcpy(windows_version, "ME");
			} 
			break;

		case VER_PLATFORM_WIN32s:
			strcpy(windows_version, "Win32s");
			break;
		}

		return windows_version; 
	}


/* disabled cause it generates annoying warnings ... and I don't want to
	take time to do it the new ms way. */
	
	static void getWindowsVersion(int *os, int *major, int *minor)//, int *win)
	{
		/*
		extern unsigned int _osver;
		extern unsigned int _winmajor;
		extern unsigned int _winminor;
		extern unsigned int _winver;

		*os = _osver;
		*major = _winmajor;
		*minor = _winminor;
		*win = _winver;
		*/

		OSVERSIONINFO v;
		ZeroMemory(&v, sizeof(v));
		v.dwOSVersionInfoSize = sizeof(v);

		GetVersionEx(&v);

		*os = v.dwBuildNumber;
		*major = v.dwMajorVersion;
		*minor = v.dwMinorVersion;
		//*win = v.dwPlatformId;

	}
/**/


	static bool isNT()
	{
		OSVERSIONINFO osvi;
		ZeroMemory(&osvi, sizeof(osvi));
		osvi.dwOSVersionInfoSize = sizeof(osvi);
		GetVersionEx(&osvi);
		return (osvi.dwPlatformId == VER_PLATFORM_WIN32_NT);
	}


	// Returns currently installed DirectX major version number or
	// 0, if it can't be determined.
	static int getDirectXVersion()
	{
		int dxv = 0;
		const char *root = "Software\\Microsoft\\DirectX";
		const char *key = "Version";
		HKEY hk;
		if(RegCreateKey(HKEY_LOCAL_MACHINE, root, &hk) == 0)
		{
			char valbuf[50];
			DWORD valsize = sizeof(valbuf);
			DWORD valtype;
			if((RegQueryValueEx(hk, key, NULL, &valtype, (LPBYTE)valbuf, &valsize) == ERROR_SUCCESS) && (valtype == REG_SZ))
			{
				if(sscanf(valbuf, "4.%d.", &dxv) != 1)
					dxv = 0;
			}
			RegCloseKey(hk);
		}
		return dxv;
	}


	// percent of memory in use
	static int memoryLoad()
	{
	  MEMORYSTATUS stat;
	  GlobalMemoryStatus (&stat);
	  return stat.dwMemoryLoad;
	}

	// bytes of physical memory
	static unsigned long physicalMemoryTotal()
	{
	  MEMORYSTATUS stat;
	  GlobalMemoryStatus (&stat);
	  return (unsigned long)stat.dwTotalPhys;
	}

	// bytes of physical memory in use
	static unsigned long physicalMemoryFree()
	{
	  MEMORYSTATUS stat;
	  GlobalMemoryStatus (&stat);
	  return (unsigned long)stat.dwAvailPhys;
	}
		/*
	  printf ("There are %*ld total %sbytes of paging file.\n",
			  WIDTH, stat.dwTotalPageFile/DIV, divisor);
	  printf ("There are %*ld free %sbytes of paging file.\n",
			  WIDTH, stat.dwAvailPageFile/DIV, divisor);
	  printf ("There are %*lx total %sbytes of virtual memory.\n",
			  WIDTH, stat.dwTotalVirtual/DIV, divisor);
	  printf ("There are %*lx free %sbytes of virtual memory.\n",
			  WIDTH, stat.dwAvailVirtual/DIV, divisor);
		*/


	static int getExePath(char *buf, int len)
	{
		return GetModuleFileName(GetModuleHandle(NULL), buf, len);
	}


	static const char *getTempDirPath()
	{
		static const char *possibles[] = {
			"c:\\windows\\temp",
			"c:\\winnt\\temp",
			"c:\\temp",
			"d:\\windows\\temp",
			"d:\\winnt\\temp",
			"d:\\temp",
		};
		for(unsigned int i = 0; i < (sizeof(possibles) / sizeof(const char *)); i++)
		{
			File path(possibles[i]);
			if(path.isDir())
				return possibles[i];
		}
		return "c:\\";
	}

	static char *dupstr(const char *s)
	{
		char *n = new char[strlen(s) + 1];
		if(n)
			strcpy(n, s);
		return n;
	}

	// Gets the full path to the dir from which the exe is running, and
	// stores it into 'buf'. 
	static void getExePath(const char *a, char *buf, int len)
	{
		char *s = dupstr(a);
		char *lastslash = strrchr(s, '\\');
		if(lastslash)
			*lastslash = 0;
		Str::copy(buf, s, len);
		free(s);
	}


	// Runs an executable given a full command line such as:
	//    "\"c:\program files\sleepless\monkeys\butt.exe\" \"arg1\" arg2"
	// Note the embedded double quotes.
	// The exe is launched and runs independantly of the calling prog.
	// The caller does not wait for the launched prog in any way, nor
	// is any return code from the launched prog returned or made available
	// in any way.
	// Returns -1 on failure
	// If 'waitforit' is false, returns 0 on success
	// Otherwise, returns exit code of launched process
	static int launchProgram(const char *cmd, bool waitforit = false, int *rcvpid = 0)
	{
		STARTUPINFO si;
		memset(&si, 0, sizeof(si));
		si.cb = sizeof(si);
		PROCESS_INFORMATION pi;
		if(CreateProcess(0, (char *)cmd, NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi))
		{
			if(rcvpid)
				*rcvpid = pi.dwProcessId;
			if(waitforit)
			{
				unsigned long rc;
				WaitForSingleObject(pi.hProcess, INFINITE);
				GetExitCodeProcess(pi.hProcess, &rc);
				CloseHandle(pi.hThread);
				CloseHandle(pi.hProcess);
				return rc;
			}
			return 0;
		}
		return -1;
	}

	/*
	static int shellExec(const char *cmd, bool waitforit = false, int *rcvpid = 0)
	{
		STARTUPINFO si;
		memset(&si, 0, sizeof(si));
		si.cb = sizeof(si);
		PROCESS_INFORMATION pi;
		if(CreateProcess(0, (char *)cmd, NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi))
		{
			if(rcvpid)
				*rcvpid = pi.dwProcessId;
			if(waitforit)
			{
				unsigned long rc;
				WaitForSingleObject(pi.hProcess, INFINITE);
				GetExitCodeProcess(pi.hProcess, &rc);
				CloseHandle(pi.hThread);
				CloseHandle(pi.hProcess);
				return rc;
			}
			return 0;
		}
		return -1;
	}
	*/

	/* check the status of process.
		returns:
			-1	if pid is invalid, or doesn't correspond to a valid process.
			0	if pid corresponds to a valid process, and process is still running.
			pid	if pid corresponds to a valid process, and process has exited.
		if return is pid and rc is non-0, then rc will be filled in with process' exit code.
		*/
	static int checkProcess(int pid, unsigned long *rc = 0)
	{
		if(pid >= 1)
		{
			HANDLE proc = OpenProcess(SYNCHRONIZE|PROCESS_QUERY_INFORMATION, 0, pid);
			if(proc)
			{
				int r = WaitForSingleObject(proc, 0);
				if(rc)
					GetExitCodeProcess(proc, rc);
				CloseHandle(proc);
				return (r == WAIT_TIMEOUT) ? 0 : pid;
			}
		}
		return -1;
	}

	static void killWindow(HWND win, LPARAM lp)
	{
		DWORD id;
		GetWindowThreadProcessId(win, &id);
		if(id == (DWORD)lp)
			PostMessage(win, WM_CLOSE, 0, 0);
	}

	// returns 0 on success
	static int killProcess(int pid)
	{
		if(pid < 1)
			return 1;
		HANDLE proc = OpenProcess(SYNCHRONIZE|PROCESS_TERMINATE, 0, pid);
		if(!proc)
			return 1;
		EnumWindows((WNDENUMPROC)killWindow, (LPARAM)pid);
		if(WaitForSingleObject(proc, 2000) == WAIT_OBJECT_0)
			return 0;
		int r = TerminateProcess(proc, 0) ? 0 : 1;
		CloseHandle(proc);
		return r;
	}

	static int killProcess(const char *pat)
	{
		int pid = 0;

		PROCESSENTRY32 pe32 = {sizeof (PROCESSENTRY32)};

		HANDLE hProcSnap = CreateToolhelp32Snapshot (TH32CS_SNAPPROCESS, 0);
		if (hProcSnap == INVALID_HANDLE_VALUE) return 0;

		if (Process32First (hProcSnap, &pe32))
		{
			do {
				S s1(pe32.szExeFile);
				if(s1.contains(pat))
				{
					pid = pe32.th32ProcessID;
					break;
				}
			} while (Process32Next (hProcSnap, &pe32));
		}

		CloseHandle (hProcSnap);
	
		return killProcess(pid);
	}


	// Get path to Start Menu 'Programs' folder.
	// 'buf' must be at least MAX_PATH+1 bytes in size.
	// Returns 0 on success.
	// There is probably a memory in here somewhere, but ... ask me if I care.
	static int getStartMenuProgramsPath(char *buf)
	{
		LPITEMIDLIST pidl;
		if(SHGetSpecialFolderLocation(0, CSIDL_PROGRAMS, &pidl) == NOERROR) { 
			if (SHGetPathFromIDList(pidl, buf)) 
			{
				return 0;
			}
		} 
		return 1;
	}

	static int getDesktopPath(char *buf)
	{
		LPITEMIDLIST pidl;
		if(SHGetSpecialFolderLocation(0, CSIDL_DESKTOP, &pidl) == NOERROR)
		{ 
			if (SHGetPathFromIDList(pidl, buf)) 
			{
				return 0;
			}
		}
		return 1;
	}


	/* Get path to the 'Programs Files' folder.  Returns 1 on success, 0 on failure */
	static int getProgramFilesPath(char *buf, int bufsize)
	{
		int r = 0;
		const char *root = "Software\\Microsoft\\Windows\\CurrentVersion";
		const char *key = "ProgramFilesDir";
		HKEY hk;
		if(RegCreateKey(HKEY_LOCAL_MACHINE, root, &hk) == 0)
		{
			DWORD valsize = bufsize;
			DWORD valtype;
			if((RegQueryValueEx(hk, key, NULL, &valtype, (LPBYTE)buf, &valsize) == ERROR_SUCCESS) && (valtype == REG_SZ))
			{
				r = 1;
			}
			RegCloseKey(hk);
		}
		return r;
	}


	// Get path to Start Menu folder.
	// 'buf' must be at least MAX_PATH+1 size.
	// Returns 0 on success.
	// There is probably a memory in here somewhere, but ... ask me if I care.
	static int getStartMenuPath(char *buf)
	{
		LPITEMIDLIST pidl;
		if(SHGetSpecialFolderLocation(0, CSIDL_STARTMENU, &pidl) == NOERROR) { 
			if (SHGetPathFromIDList(pidl, buf)) 
			{
				return 0;
			}
		} 
		return 1;
	} 


	// An "Oh my god!" dialog with "OK" button showing last windows error
	static void alertWinError(HWND w, const char *prompt)
	{
		LPVOID lpMsgBuf = 0;
		int err = GetLastError();

		FormatMessage( 
			FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
			NULL,
			err,
			MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
			(LPTSTR) &lpMsgBuf,
			0,
			NULL );
		MessageBox(w, (const char *)lpMsgBuf, prompt, MB_OK|MB_ICONINFORMATION);
		LocalFree(lpMsgBuf);
	}

	// An "Oh my god!" dialog with "OK" button showing last windows error
	static void alertWinError(HWND w)
	{
		alertWinError(w, "Windows Error");
	}

	// An "Oh my god!" dialog with "OK" button showing last windows error
	static void alertWinError()
	{
		alertWinError(0, "Windows Error");
	}

	// An "Oh my god!" dialog with "OK" button
	static void alert(HWND w, const char *prompt, const char *msg)
	{
		MessageBox(w, msg, prompt, MB_OK |  MB_ICONEXCLAMATION );
	}

	// An "Oh my god!" dialog with "OK" button
	static void alert(const char *prompt, const char *msg)
	{
		MessageBox(0, msg, prompt, MB_OK |  MB_ICONEXCLAMATION );
	}

	// An "Oh my god!" dialog with "OK" button
	static void alert(HWND w, const char *msg)
	{
		alert(w, "Alert", msg);
	}

	// An "Oh my god!" dialog with "OK" button
	static void alert(const char *msg)
	{
		alert((HWND)0, msg);
	}

	// A YES/NO dialog.  Returns true if YES was clicked.
	static bool query(HWND w, const char *prompt, const char *msg)
	{
		return MessageBox(w, msg, prompt, MB_YESNO|MB_ICONQUESTION) == IDYES;
	}

	static bool query(const char *prompt, const char *msg)
	{
		return query(0, prompt, msg);
	}

	// An simple message dialog with "OK" button
	static void msg(HWND w, const char *prompt, const char *m)
	{
		MessageBox(w, m, prompt, MB_OK);
	}

	static void msg(const char *prompt, const char *m)
	{
		msg(0, prompt, m);
	}


	// Returns 0 on success
	// target	- path of the target file/dir
	// name		- path of the actual link
	// desc		- description of link
/*
	static HRESULT was_createLink(const char *target, const char *name, const char *desc)
	{
		if(!desc)
			desc = "";

		if(CoInitialize(0) != S_OK)
			return 1;

		IShellLink* psl = 0; 
		HRESULT hres = CoCreateInstance(CLSID_ShellLink, NULL, CLSCTX_INPROC_SERVER, IID_IShellLink, (LPVOID*)&psl); 
		if(SUCCEEDED(hres)) 
		{
			IPersistFile* ppf; 

			psl->SetPath(target); 
			psl->SetDescription(desc); 
	 
			hres = psl->QueryInterface(IID_IPersistFile, (LPVOID*)&ppf); 
			if (SUCCEEDED(hres)) 
			{ 
				WCHAR wsz[MAX_PATH]; 
	 
				// Ensure string is Unicode. 
				MultiByteToWideChar(CP_ACP, 0, name, -1, wsz, MAX_PATH);

				// XXX Add code to check success of MultiByteWideChar()?
	 
				hres = ppf->Save(wsz, TRUE); 	// store the link to disk
				ppf->Release(); 
			} 
			psl->Release(); 
		} 
		return hres;
	}
*/

	// Creates shortcut
	// Returns 0 on success.
	// 'target' is the path of the file/dir to which the shortcut leads
	// 'sc' is the path that the shortcut itself will have (without .lnk ext)
	// 'icon' is the path to a file which contains the icon for shortcut
	static int mkShortcut(const char *target, const char *sc, const char *icon)
	{
		int r = -1;
		if(CoInitialize(0) == 0)
		{
			IShellLinkW *isl;
			if(CoCreateInstance(CLSID_ShellLink, NULL, CLSCTX_INPROC_SERVER, IID_IShellLinkW, (LPVOID *)&isl) == 0)
			{
				WCHAR w[MAX_PATH];
				MB2WC(target, w);
				isl->SetPath(w);
				PathRemoveFileSpecW(w);
				isl->SetWorkingDirectory(w);
				if(icon && *icon)
				{
					MB2WC(icon, w);
					isl->SetIconLocation(w, 0);
				}
				IPersistFile *ipf = 0;
				if(isl->QueryInterface(IID_IPersistFile, (LPVOID *)&ipf) == 0)
				{
					MB2WC(S(sc,".lnk"), w);
					if(ipf->Save(w, TRUE) == 0)
						r = 0;
					ipf->Release();
				}
				isl->Release();
			}
			CoUninitialize();
		}
		return r;
	}


	// Creates shortcut/icon in start menu
	// Returns 0 on success.
	// 'folder' will be created as a directory under your Start
	//    menu's "Programs" folder.  If the folder already exists, the
	//    folder creation step is skipped.
	// 'name' is the name that that shortcut/icon will have
	// 'tdir' is the full path to the dir where 'target' is located.
	// 'target' is the name of the item you want to link to.
	// 'iconfile' is the name of a file relative to 'tdir' which contains
	//    the icon that you want the shortcut to have.
	static int addProgramsLink(const char *folder, const char *name, const char *tdir, const char *target, const char *iconfile, wchar_t *uni = 0)
	{
		// Create the full path of the startmenu->programs folder
		char programs[MAX_PATH + 1];
		Windows::getStartMenuProgramsPath(programs);
//printf("===== programs dir is %s\n", programs);

		// Create the given dir under 'programs'
		char path[MAX_PATH + 1];
		Str::copy(path, programs, sizeof(path));
		Str::append(path, "\\", sizeof(path));
		Str::append(path, folder, sizeof(path));
//printf("===== creating dir %s\n", path);
		File f(path);
		if(!f.isDir())
		{
			if(Directory::createDir(path, '\\'))
				return -1;
		}

		Str::copy(path, programs, sizeof(path));
		Str::append(path, "\\", sizeof(path));
		Str::append(path, folder, sizeof(path));
		Str::append(path, "\\", sizeof(path));
		Str::append(path, name, sizeof(path));
		Str::append(path, ".lnk", sizeof(path));
//printf("===== path is %s\n", path);

		/* Find the full name of the target */
		char targetpath[MAX_PATH];
		Str::copy(targetpath, tdir, sizeof(targetpath));
		Str::append(targetpath, "\\", sizeof(targetpath));
		Str::append(targetpath, target, sizeof(targetpath));
//printf("===== targetpath is %s\n", targetpath);

		
		// Actually make the link by doing some stupid COM shit
		if(CoInitialize(0) == S_OK)
		{
			WCHAR w[MAX_PATH];

			IShellLinkW *slink = NULL;
			HRESULT hres = CoCreateInstance(CLSID_ShellLink, NULL, CLSCTX_INPROC_SERVER, IID_IShellLinkW, (LPVOID*)&slink);
			if(!SUCCEEDED(hres))
			{
				CoUninitialize();
				return -1;
			}

			MultiByteToWideChar(CP_ACP, 0, targetpath, -1, w, MAX_PATH);
			slink->SetPath(w);
			MultiByteToWideChar(CP_ACP, 0, tdir, -1, w, MAX_PATH);
			slink->SetWorkingDirectory(w);

			MultiByteToWideChar(CP_ACP, 0, name, -1, w, MAX_PATH);
			if(uni)
				slink->SetDescription(uni);
			else
				slink->SetDescription(w);

			if(iconfile && *iconfile)
			{
				char iconpath[MAX_PATH];
				Str::copy(iconpath, tdir, sizeof(iconpath));
				Str::append(iconpath, "\\", sizeof(iconpath));
				Str::append(iconpath, iconfile, sizeof(iconpath));
				MultiByteToWideChar(CP_ACP, 0, iconpath, -1, w, MAX_PATH);
				slink->SetIconLocation(w, 0);
			}

			IPersistFile *pfile = NULL;
			hres = slink->QueryInterface(IID_IPersistFile, (LPVOID*)&pfile);
			if(!SUCCEEDED(hres))
			{
				slink->Release();
				CoUninitialize();
				return -1;
			}

			if(false) //uni)
			{
				Str::copy(path, programs, sizeof(path));
				Str::append(path, "\\", sizeof(path));
				Str::append(path, folder, sizeof(path));
				Str::append(path, "\\", sizeof(path));
				MultiByteToWideChar(CP_ACP, 0, path, -1, w, MAX_PATH);
				lstrcatW(w, uni);
				lstrcatW(w, L".lnk");
				//Str::append(path, name, sizeof(path));
				//Str::append(path, ".lnk", sizeof(path));
				hres = pfile->Save(w, TRUE);
			}
			else
			{
				MultiByteToWideChar(CP_ACP, 0, path, -1, w, MAX_PATH);
				hres = pfile->Save(w, TRUE);
			}
			slink->Release();
			pfile->Release();
			if(!SUCCEEDED(hres))
			{
				CoUninitialize();
				return -1;
			}
			CoUninitialize();
		}

		return 0;
	}

	// Creates shortcut/icon on desktop
	// Returns 0 on success.
	// 'name' is the name that that shortcut/icon will have
	// 'tdir' is the full path to the dir where 'target' is located.
	// 'target' is the name of the item you want to link to.
	// 'iconfile' is the name of a file relative to 'tdir' which contains
	//    the icon that you want the shortcut to have.
	static int addDesktopLink(const char *name, const char *tdir, const char *target, const char *iconfile)
	{
		// Create the full path of the startmenu->programs folder
		char desktop[MAX_PATH + 1];
		Windows::getDesktopPath(desktop);

		char path[MAX_PATH + 1];

		Str::copy(path, desktop, sizeof(path));
		Str::append(path, "\\", sizeof(path));
		Str::append(path, name, sizeof(path));
		Str::append(path, ".lnk", sizeof(path));

		/* Find the full name of the target */
		char targetpath[MAX_PATH];
		Str::copy(targetpath, tdir, sizeof(targetpath));
		Str::append(targetpath, "\\", sizeof(targetpath));
		Str::append(targetpath, target, sizeof(targetpath));

		// Actually make the link by doing some stupid COM shit
		if(CoInitialize(0) == S_OK)
		{
			IShellLink *slink = NULL;
			HRESULT hres = CoCreateInstance(CLSID_ShellLink, NULL, CLSCTX_INPROC_SERVER, IID_IShellLink, (LPVOID*)&slink);
			if(!SUCCEEDED(hres))
			{
				CoUninitialize();
				return -1;
			}
			slink->SetPath(targetpath);
			slink->SetWorkingDirectory(tdir);
			slink->SetDescription(name);
			if(iconfile && *iconfile)
			{
				char iconpath[MAX_PATH];
				Str::copy(iconpath, tdir, sizeof(iconpath));
				Str::append(iconpath, "\\", sizeof(iconpath));
				Str::append(iconpath, iconfile, sizeof(iconpath));
				slink->SetIconLocation(iconpath, 0);
			}

			IPersistFile *pfile = NULL;
			hres = slink->QueryInterface(IID_IPersistFile, (LPVOID*)&pfile);
			if(!SUCCEEDED(hres))
			{
				slink->Release();
				CoUninitialize();
				return -1;
			}

			WCHAR widepath[MAX_PATH];
			MultiByteToWideChar(CP_ACP, 0, path, -1, widepath, MAX_PATH);
			hres = pfile->Save(widepath, TRUE);
			slink->Release();
			pfile->Release();
			if(!SUCCEEDED(hres))
			{
				CoUninitialize();
				return -1;
			}
			CoUninitialize();
		}

		return 0;
	}

	// Draw a filled rect
	static void fillRect(HDC dc, int x, int y, int w, int h, int c)
	{
		RECT r;
		r.left = x;
		r.top = y;
		r.right = r.left + w;
		r.bottom = r.top + h;
		FillRect(dc, &r, CreateSolidBrush(c));
	}


	// Draw and unfilled rect
	static void drawRect(HDC dc, int x, int y, int w, int h, int c)
	{
		fillRect(dc, x        , y        , w, 1, c);	// top
		fillRect(dc, x        , y + h - 1, w, 1, c);	// bottom
		fillRect(dc, x        , y        , 1, h, c);	// left
		fillRect(dc, x + w - 1, y        , 1, h, c);	// right
	}


	// Draw some text
	static void drawText(HDC dc, HFONT f, int c, const char *s, int x, int y)
	{
		SelectObject(dc, f);
		SetTextColor(dc, c);
		SetBkMode(dc, TRANSPARENT);
		TextOut(dc, x, y, s, (unsigned long)strlen(s));
	}


	// Deterimine width and height of txt using len
	static void textSize(HDC dc, HFONT f, const char *s, int l, int *w, int *h)
	{
		SIZE sz;
		HGDIOBJ prevob = SelectObject(dc, f);
		GetTextExtentPoint(dc, s, l, &sz);
		SelectObject(dc, prevob);
		*w = sz.cx;
		*h = sz.cy;
	}


	// Deterimine width and height of txt
	static void textSize(HDC dc, HFONT f, const char *s, int *w, int *h)
	{
		textSize(dc, f, s, (unsigned long)strlen(s), w, h);
	}



	// Returns a font with the requested properties or NULL if unable.
	// Args:
	// 		h		- height in pixels
	//		i		- true if you want italic
	//		u		- true if you want underline
	//		b		- true if you want bold
	//		f		- name of type face, like "helvetica".
	static HFONT createFont(int h, int i, int u, int b, const char *f)
	{
		return CreateFont(
			h,								// height
			0, 								// width
			0, 								// angle of escapement 
			0, 								// base-line orientation angle 
			b ? FW_BOLD : FW_NORMAL,		// font weight 
			i,								// Italic? true/false
			u,								// Underline? true/false
			0,								// Strikeout? true/false
			DEFAULT_CHARSET,				// character set identifier 
			OUT_DEFAULT_PRECIS,				// output precision 
			CLIP_DEFAULT_PRECIS,			// clipping precision 
			ANTIALIASED_QUALITY,			// output quality 
			DEFAULT_PITCH | FF_DONTCARE,	// pitch | family 
			f								// ptr to typeface name string 
			); 
	}


	/* Try to load a bitmap by name from disk.
		If found, load it and return handle to it.
		If not found, pull bitmap with same name from compiled
		in resources.
		If not found there either, return null.
		If non-null pointers are supplied for skw and skh, they will be
		filled in with the bitmaps width and height. */
	static HBITMAP getBitmap(const char *bmname, int *skw, int *skh)
	{
		HINSTANCE inst = GetModuleHandle(NULL);

		HBITMAP bm = (HBITMAP)LoadImage(
			inst,
			bmname,
			IMAGE_BITMAP,
			0,
			0,
			LR_LOADFROMFILE | LR_DEFAULTSIZE);
		if(bm == NULL)
			bm = (HBITMAP)LoadImage(inst, bmname, IMAGE_BITMAP, 0, 0, 0);

		if(bm != NULL)
		{
			BITMAP b;
			GetObject(bm, sizeof(b), (void *)&b);
			if(skw)
				*skw = b.bmWidth;
			if(skh)
				*skh = b.bmHeight;
		}

		return bm;
	}


	static HBITMAP getBitmap(const char *bmname)
	{
		int w, h;
		return getBitmap(bmname, &w, &h);
	}


	// Manufactures a button and returns a handle to it.
	// Args:
	// 		label		label for button, such as "OK"
	//		width		width in pixels
	//		height		height in pixels
	//		x			x position 
	//		y			y position 
	//		parent		parent window
	/*
	static HWND createButton(const char *label, int width, int height, int x, int y, HWND parent)
	{
		return CreateWindow( 
			"BUTTON",	// predefined class 
			label,		// button text 
			WS_VISIBLE | WS_CHILD | BS_DEFPUSHBUTTON,  // styles 
			// Size and position values are given explicitly, because 
			// the CW_USEDEFAULT constant gives zero values for buttons. 
			x,		// starting x position 
			y,		// starting y position 
			width,		// button width 
			height,		// button height 
			parent,	// parent window 
			NULL,	// No menu 
			(HINSTANCE) GetWindowLong(parent, GWL_HINSTANCE), 
			NULL);	// pointer not needed 
	};
	*/




	// Lifted from
	//		http://www.flipcode.com/articles/article_win32skins.shtml
	// -----------------------------------------------------------------
	// Return bitmap pixels in 24bits format.
	// The caller must release the memory...
	static BYTE *get24BitPixels(HBITMAP pBitmap, WORD *pwWidth, WORD *pwHeight)
	{
		BITMAP bmpBmp; // a bitmap object just to get bitmap width and height
		LPBITMAPINFO pbmiInfo; // pointer to original bitmap info
		BITMAPINFO bmiInfo; // bitmap info will hold the new 24bit bitmap info
		WORD wBmpWidth, wBmpHeight; // width and height of the bitmap

		// get some info from the bitmap
		GetObject(pBitmap, sizeof(bmpBmp),&bmpBmp);
		pbmiInfo   = (LPBITMAPINFO)&bmpBmp;

		// get width and height
		wBmpWidth  = (WORD)pbmiInfo->bmiHeader.biWidth;
		wBmpWidth -= (wBmpWidth % 4); // width is 4 byte boundary aligned.
		wBmpHeight = (WORD)pbmiInfo->bmiHeader.biHeight;

		// copy to caller width and height parms
		*pwWidth  = wBmpWidth;
		*pwHeight = wBmpHeight;

		// allocate width * height * 24bits pixels

		int nbytes = wBmpWidth * wBmpHeight * 3;
nbytes = ((((wBmpWidth * 24) + 31) & ~31) >> 3) * wBmpHeight;
		BYTE *pPixels = new BYTE[nbytes];
		if (!pPixels)
		{
			return NULL;
		}

		// get user desktop device context to get pixels from
		HDC hDC = GetDC(NULL);

		// fill desired structure
		memset(&bmiInfo, 0, sizeof(BITMAPINFOHEADER));
		bmiInfo.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
		bmiInfo.bmiHeader.biWidth = wBmpWidth;
		bmiInfo.bmiHeader.biHeight = -wBmpHeight;
		bmiInfo.bmiHeader.biPlanes = 1;
		bmiInfo.bmiHeader.biBitCount = 24;
		bmiInfo.bmiHeader.biCompression = BI_RGB;
		bmiInfo.bmiHeader.biSizeImage = 0; //nbytes;

		// get pixels from the original bitmap converted to 24bits
		int iRes = GetDIBits(hDC, pBitmap, 0, wBmpHeight, (LPVOID)pPixels, &bmiInfo, DIB_RGB_COLORS);

if(!iRes)
 alertWinError(0, "ouch");

		ReleaseDC(NULL,hDC);

		if (!iRes)
		{
			delete pPixels;
			return NULL;
		}

		return pPixels; // return the pixel array
	}



	// Lifted from
	//		http://www.flipcode.com/articles/article_win32skins.shtml
	// And modified to get transparent color from bottom right corner.
	// If you don't want a hole in upper left corner, add 1 extra scanline
	// at bottom of your image and fill it with transparent color.
	// j.h.
	// -----------------------------------------------------------------
	// Scan a bitmap and return a perfect fit region.
	// The caller must release the region object...
	// (this method starts with a full region and excludes inside the loop)
	static HRGN scanRegion(HBITMAP pBitmap)
	{

		// bitmap width and height
		WORD wBmpWidth,wBmpHeight;

		// the final region and a temporary region
		HRGN hRgn, hTmpRgn;

		// 24bit pixels from the bitmap
		BYTE *pPixels = get24BitPixels(pBitmap, &wBmpWidth, &wBmpHeight);
		if (!pPixels)
			return NULL;

		// create our working region
		hRgn = CreateRectRgn(0,0,wBmpWidth,wBmpHeight);
		if (!hRgn)
		{
			delete pPixels;
			return NULL;
		}

		// get tranpsarent color from bottom right corner
		BYTE jTranspR = pPixels[ (wBmpWidth * wBmpHeight * 3) - 1];
		BYTE jTranspG = pPixels[ (wBmpWidth * wBmpHeight * 3) - 2];
		BYTE jTranspB = pPixels[ (wBmpWidth * wBmpHeight * 3) - 3];

		// scan the bitmap
		DWORD p=0;
		for (WORD y=0; y<wBmpHeight; y++)
		{
			for (WORD x=0; x<wBmpWidth; x++)
			{
				BYTE jRed   = pPixels[p+2];
				BYTE jGreen = pPixels[p+1];
				BYTE jBlue  = pPixels[p+0];

				if (jRed == jTranspR && jGreen == jTranspG && jBlue == jTranspB)
				{
					// remove transparent color from region
					hTmpRgn = CreateRectRgn(x,y,x+1,y+1);
					CombineRgn(hRgn, hRgn, hTmpRgn, RGN_XOR);
					DeleteObject(hTmpRgn);
				}

				p+=3;
			}
		}

		delete pPixels;

		return hRgn;
	}


	/*
		Creates a skinned window.
		You still have to handle blitting the bitmap into the window yourself
		and all other window events.
		This just creates the window and attaches the region built from
		the bitmap to it.
		The lower right corner of the bitmap must contain your transparent
		color.
		Returns NULL if the window couldn't be created.
		*/
	static HWND createSkinnedWindow(HBITMAP hbm, const char *name, WNDPROC proc)
	{
		HINSTANCE inst = GetModuleHandle(NULL);

		// Get width and height of bitmap
		BITMAP bm;
		GetObject(hbm, sizeof(bm), (void *)&bm);
		int w = bm.bmWidth;
		int h = bm.bmHeight;

		HRGN rgn = scanRegion(hbm);
		if(!rgn)
		{
			return NULL;
		}

		WNDCLASS wc;
		wc.style = CS_OWNDC;
		wc.lpfnWndProc = proc;
		wc.cbClsExtra = 0;
		wc.cbWndExtra = 0;
		wc.hInstance = inst;
		wc.hIcon = LoadIcon(inst, "APPICON");
		wc.hCursor = LoadCursor(0, IDC_ARROW);
		wc.hbrBackground = (HBRUSH)GetStockObject(BLACK_BRUSH);
		wc.lpszMenuName = NULL;
		wc.lpszClassName = name;

		if (!RegisterClass(&wc))
		{
			return false;
		}

		// make a rectangle on the center of the screen
		int iSw = (WORD)GetSystemMetrics(SM_CXSCREEN);
		int iSh = (WORD)GetSystemMetrics(SM_CYSCREEN);
		RECT rc = { (iSw - w)/2, (iSh - h)/2, w, h };

		// note the WS_POPUP flag, no caption, no borders, no nothing.
		HWND win = CreateWindow(name, name, WS_POPUP, rc.left,rc.top, w, h, NULL, NULL, inst, NULL);

		if(!win)
		{
			return false;
		}

		SetWindowRgn(win, rgn, true);

		DWORD dwStyle = GetWindowLong(win, GWL_STYLE);
		dwStyle &= ~(WS_CAPTION|WS_SIZEBOX);
		SetWindowLong(win, GWL_STYLE, dwStyle);

		InvalidateRect(win, NULL, FALSE);

		return win;
	}



	/*
		Creates a bland window with a specified width/height.
		You have to handle events yourself.
		Returns NULL if the window couldn't be created.
		*/
	static HWND createBlandWindow(const char *name, int w, int h, WNDPROC proc)
	{
		HINSTANCE inst = GetModuleHandle(NULL);

		WNDCLASSEX wcex;
		wcex.cbSize = sizeof(WNDCLASSEX); 
		wcex.style = CS_OWNDC;
		wcex.lpfnWndProc = proc;
		wcex.cbClsExtra = 0;
		wcex.cbWndExtra = 0;
		wcex.hInstance = inst;
		wcex.hIcon = LoadIcon(inst, "APPICON");
		wcex.hCursor = LoadCursor(0, IDC_ARROW);
		wcex.hbrBackground = (HBRUSH)GetStockObject(BLACK_BRUSH);
		wcex.lpszMenuName = NULL;
		wcex.lpszClassName = name;
		wcex.hIconSm = 0;

		if(!RegisterClassEx(&wcex))
			return 0;

		// make a rectangle on the center of the screen
		//int w = (WORD)GetSystemMetrics(SM_CXSCREEN);
		//int h = (WORD)GetSystemMetrics(SM_CYSCREEN);

		// note the WS_POPUP flag, no caption, no borders, no nothing.
		HWND win = CreateWindowEx(0, name, name, WS_POPUP, 0, 0, w, h, NULL, NULL, inst, NULL);

		if(!win)
		{
			return 0;
		}

		return win;
	}



	/*
		Creates a bland, full-screen window.
		You have to handle events yourself.
		Returns NULL if the window couldn't be created.
		*/
	static HWND createFullScreenWindow(const char *name, WNDPROC proc)
	{
		int w = (WORD)GetSystemMetrics(SM_CXSCREEN);
		int h = (WORD)GetSystemMetrics(SM_CYSCREEN);
		return createBlandWindow(name, w, h, proc);
	}



	// Creates an ordinary window.
	// If an icon resource with the name "APPICON" is present, that will
	// be used in the window class.
	// The overall window will be larger than w,h, as this function attempts
	// to create a window whose "client area" is w,h in size.
	static HWND createStandardWindow(const char *name, int w, int h, WNDPROC proc)
	{
		HINSTANCE inst = GetModuleHandle(NULL);

		WNDCLASSEX wcx; 
		wcx.cbSize = sizeof(wcx);
		wcx.style = CS_HREDRAW | CS_VREDRAW;
		wcx.lpfnWndProc = proc;
		wcx.cbClsExtra = 0;
		wcx.cbWndExtra = 0;
		wcx.hInstance = inst;
		wcx.hIcon = LoadIcon(inst, "APPICON");
		wcx.hCursor = LoadCursor(NULL, IDC_ARROW);
		wcx.hbrBackground = NULL; //(HBRUSH)GetStockObject(WHITE_BLACK);
		wcx.lpszMenuName =  NULL;
		wcx.lpszClassName = name;
		wcx.hIconSm = NULL;
 
		if (!RegisterClassEx(&wcx))
			return false;

		unsigned long styles = 
			WS_OVERLAPPED |
			WS_CAPTION |
			WS_SYSMENU |
			WS_MINIMIZEBOX |
			0;
		RECT r;
		r.left = 0;
		r.top = 0;
		r.right = w - 1;
		r.bottom = h - 1;
		AdjustWindowRect(&r, styles, 0);
		HWND win = CreateWindow(
			name,
			name,
			styles,
			CW_USEDEFAULT,
			CW_USEDEFAULT,
			r.right - r.left + 1,
			r.bottom - r.top + 1,
			NULL,
			(HMENU) NULL,
			inst,
			(LPVOID) NULL);

		if(!win)
			return 0;

		return win;
	}



	///////////////////////////////////////////////////////////////////
	// This old registry manipulation stuff should probably be looked
	// some day to make sure it's sensible.
	// I just rolled it in from a different header file.
	///////////////////////////////////////////////////////////////////

	static char *regGetStr(HKEY top, const char *path, const char *key) 
	{
		char *val = 0;
		HKEY hk;
		if( ! RegCreateKey(top, path, &hk) )
		{
			char valbuf[256];
			memset(valbuf, 0, sizeof(valbuf));	// zero out buffer
			DWORD valsize = sizeof(valbuf) - 1;	// leave a terminating 0 just in case
			DWORD valtype;
			if(RegQueryValueEx(hk, key, NULL, &valtype, (LPBYTE)valbuf, &valsize) == ERROR_SUCCESS)
			{
				if(valtype == REG_SZ)
				{
					val = dupstr(valbuf);
				}
				else
				if(valtype == REG_DWORD)
				{
					sprintf(valbuf, "%d",*((int *)valbuf));
					val = dupstr(valbuf);
				}
			}
			RegCloseKey(hk);
		}
		return val;
	}


	static char *regGetStr(const char *path, const char *key) 
	{
		return regGetStr(HKEY_CURRENT_USER, path, key) ;
	}


	// returns true if key was set ok
	static int regSetStr(HKEY top, const char *path, const char *key, const char *value)
	{
		int r = 0;
		HKEY hk;
		if( ! RegCreateKey(top, path, &hk) )
		{
			RegSetValueEx(hk, (LPCTSTR)key, 0, REG_SZ, (const unsigned char *)value, (DWORD)strlen(value) + 1);
			RegCloseKey(hk);
			// XXX get real/useful return value here??
			r = 1;
		}
		return r;
	}

	static int regSetStr(const char *path, const char *key, const char *value)
	{
		return regSetStr(HKEY_CURRENT_USER, path, key, value);
	}


	static void regDeleteKey(HKEY top, const char *key) 
	{
		RegDeleteKey(top, key);
	}

	static void regDeleteKey(const char *key) 
	{
		regDeleteKey(HKEY_CURRENT_USER, key);
	}

	/*
	static void regDeleteValue(HKEY top, const char *value) 
	{
		HKEY hkey;
		RegOpenKey(HKEY_LOCAL_MACHINE, "SOFTWARE\\MICROSOFT\\WINDOWS\\CurrentVersion\\Run", &hkey);
		RegDeleteValue(hkey, "JPJWatcher");	// xxx should that be "value" or something??
		RegCloseKey(hkey);
	}
	*/

	static void regFreeStr(char *s)
	{
		free(s);
	};


	/*
		Set up mime-type registry entries so that attempting
		to open any file or URL ending in our magic extension
		results in the launching of the program we just downloaded.

		Like this:
		
			REGEDIT4

			[HKEY_CLASSES_ROOT\MIME\Database\Content Type\application/boo]
			"Extension"=".boo"

			[HKEY_CLASSES_ROOT\.boo]
			@="boofile"
			"Content Type"="application/boo"

			[HKEY_CLASSES_ROOT\boofile]
			@="Boo"
			"EditFlags"=hex:00,00,01,00

			[HKEY_CLASSES_ROOT\boofile\shell]
			@=""

			[HKEY_CLASSES_ROOT\boofile\shell\open]
			"EditFlags"=hex:01,00,00,00

			[HKEY_CLASSES_ROOT\boofile\shell\open\command]
			@="c:\\program files\\boo\\webupdate.exe %1"
	*/
	static void regRegisterFileType(const char *exePath, const char *ext)
	{
		char buf1[128];
		char buf2[128];

		sprintf(buf1, "MIME\\Database\\Content Type\\application/%s", ext);
		sprintf(buf2, ".%s", ext);

		regSetRegKey(HKEY_CLASSES_ROOT,
			buf1, REG_SZ, (const unsigned char *)"Extension", buf2, 6);

		regSetRegKey(HKEY_CLASSES_ROOT,
			buf2, REG_SZ, (const unsigned char *)"Content Type", buf1, 17);

		sprintf(buf1, "%sfile", ext);
		sprintf(buf2, ".%s", ext);

		regSetRegKey(HKEY_CLASSES_ROOT,
			buf2, REG_SZ, (const unsigned char *)"", buf1, 9);

		regSetRegKey(HKEY_CLASSES_ROOT,
			buf1, REG_SZ, (const unsigned char *)NULL, ext, 5);
		
		static const unsigned char  hex1[4] =  { 0x00, 0x00, 0x01, 0x00 };
		regSetRegKey(HKEY_CLASSES_ROOT,
			buf1, REG_BINARY, (const unsigned char *)"EditFlags",
			(char *)hex1, sizeof(hex1));
		
		strcat(buf1, "\\shell");
		regSetRegKey(HKEY_CLASSES_ROOT,
			buf1, REG_SZ, (const unsigned char *)NULL, "", 0);

		strcat(buf1, "\\open");
		static const unsigned char  hex2[4] =  { 0x01, 0x00, 0x00, 0x00 };
		regSetRegKey(HKEY_CLASSES_ROOT,
			buf1, REG_BINARY, (const unsigned char *)"EditFlags",
			(char *)hex2, sizeof(hex2));
		
		strcat(buf1, "\\command");
		char * exePlus = new char [strlen(exePath) + 8];
		sprintf(exePlus, "\"%s\" \"%%1\"", exePath);

		regSetRegKey(
			HKEY_CLASSES_ROOT,
			buf1,
			REG_SZ,
			NULL,
			exePlus, (int)strlen(exePlus));

		delete exePlus;
	}

	static void regSetRegKey(
			HKEY top,
			const char *root,
			DWORD type,
			const unsigned char *key,
			LPCTSTR hex,
			int len)
	{
		HKEY hk;
		if(!RegCreateKey(top, root, &hk))
		{
			RegSetValueEx(hk,(LPCTSTR)key,0,type,(const unsigned char *)hex,len);
			RegCloseKey(hk);
		}
		return;
	}


	//////////////////////////////////////////////////////////////////////


	static int elevateExe(const char *exe, const char *guid)
	{
		S g("{",guid,"}");
		S path("Software\\Microsoft\\Internet Explorer\\Low Rights\\ElevationPolicy\\",g);
		HKEY hkey;
		if(RegCreateKey(HKEY_CURRENT_USER, path, &hkey) == 0)
		{
			S d(exe);
			d.chrepl('/', '\\');
			d.rhead('\\');
			S f(exe);
			f.chrepl('/', '\\');
			f.rtail('\\');
			const unsigned char *s;
			s = (const unsigned char *)((const char *)f);
			RegSetValueEx(hkey, "AppName", 0, REG_SZ, s, strlen(f)+1);
			s = (const unsigned char *)((const char *)d);
			RegSetValueEx(hkey, "AppPath", 0, REG_EXPAND_SZ, s, strlen(d)+1);
			DWORD dw = 3;
			s = (const unsigned char *)(&dw);
			RegSetValueEx(hkey, "Policy", 0, REG_DWORD, s, sizeof(dw));
			RegCloseKey(hkey);
		}
		else
		{
			// alertWinError();
		}

		return 0;
	}


	// Tracks down the MacroMedia Shockwave directory using the registry 
	// and stores it in the buffer provided by the caller.
	// Returns 0 on success.
	static int getShockwaveDir(char *buf, int buflen)
	{
		const char *key = "Software\\Macromedia\\Shockwave 8\\location\\coreplayer";
		int rval; 
		HKEY rk; 
		unsigned long sz, typ; 

		sz = buflen - 1;

		rval = RegOpenKeyEx(HKEY_CURRENT_USER, key, 0, KEY_READ, &rk); 
		if(rval != ERROR_SUCCESS) 
			return 1; 

		rval = RegQueryValueEx(rk, "", NULL, &typ, (unsigned char*)buf, &sz); 
		if(rval != ERROR_SUCCESS) 
			return 1; 

		RegCloseKey(rk); 

		return 0; 
	} 

	static int getDirectorDir(char *buf, int buflen)
	{
		const char *pth = "C:\\Program Files\\Macromedia\\Director 8.5";
		//File dirdir(pth);
		//if(dirdir.isDir())
			Str::copy(buf, pth, buflen);
		return 0; 
	} 

	// Changes current working dir to the MacroMedia Shockwave dir.
	// Calls getShockwaveDir() to find it.
	// Returns 0 on success
	static int gotoShockwaveDir()
	{
		char buf[300];
		if(getShockwaveDir(buf, sizeof(buf)))
			return chdir(buf); //System::chdir(buf);
		return 1;
	}


	////////////////////////////////////////////////////////////

	// Cracks up a URL in place.
	// A full ascii url (such as "http://host.com:port/path") is passed
	// in as 'ourl'
	// The pointer-to-pointer for host and path are filled in with pointers
	// into the 'ourl' string where those parts start and the parts are
	// terminated with 0's.  The pointer-to-int 'port' is filled in
	// with the port number.
	static bool crackUrl(char *ourl, char **host, int *port, char **path, bool *ssl)
	{
		char *url = ourl;
		// remove trailing slash if any.
		if(url[strlen(url) - 1] == '/')
			url[strlen(url) - 1] = 0;

		URL_COMPONENTS urlc;
		memset(&urlc, 0, sizeof(urlc));
		urlc.dwStructSize = sizeof(urlc);
		urlc.dwSchemeLength = 1;
		urlc.dwHostNameLength = 1;
		urlc.dwUrlPathLength = 1;
		urlc.dwExtraInfoLength = 1;
		BOOL b = InternetCrackUrl(url, 0, 0, &urlc);
		if(b)
		{
			char *cp;

			cp = urlc.lpszHostName;
			cp[urlc.dwHostNameLength] = 0;
			*host = cp;

			*port = urlc.nPort;

			cp = urlc.lpszUrlPath;
			cp[urlc.dwUrlPathLength] = 0;
			*path = cp;

			*ssl = true;
			if((urlc.dwSchemeLength == 4) && (_strnicmp(urlc.lpszScheme, "http", 4) == 0))
			{
				*ssl = false;
			}
		}
		return b ? true : false;
	}




#ifdef WIN32
	static int getMACAddress(int a, unsigned char *macaddr)
	{
		return FALSE;
#if 0
#define lNAME_SIZE 1024
		NCB ncb;

		::ZeroMemory(&ncb, sizeof(NCB));

		ncb.ncb_command = NCBRESET;
		ncb.ncb_lsn = 0x00;
		ncb.ncb_callname[0] = 20;
		ncb.ncb_callname[2] = 100;
		ncb.ncb_lana_num = a;

		UCHAR uRet = Netbios(&ncb);
		if(uRet != NRC_GOODRET)
			return FALSE;

		BYTE buffer[lNAME_SIZE+2];
		ADAPTER_STATUS *pAS;

		::ZeroMemory(&ncb, sizeof(NCB));
		::ZeroMemory(buffer, lNAME_SIZE+2);

		ncb.ncb_command = NCBASTAT;
		ncb.ncb_buffer = buffer;
		ncb.ncb_length = lNAME_SIZE;
		ncb.ncb_callname[0] = '*';
		ncb.ncb_lana_num = a;

		uRet = Netbios(&ncb);
		if(uRet != NRC_GOODRET)
			return FALSE;
		
		pAS = (ADAPTER_STATUS *)buffer;
		memcpy(macaddr, &(pAS->adapter_address), 6);

#endif
		return TRUE;
	}
#endif


#if 0


//#include <Nb30.h>
//const long lNAME_SIZE = 1024;
#define lNAME_SIZE 1024

static BOOL ResetAdapter(UCHAR lana)
{
	NCB ncb;

	::ZeroMemory(&ncb, sizeof(NCB));

	ncb.ncb_command = NCBRESET;
	ncb.ncb_lsn = 0x00;
	ncb.ncb_callname[0] = 20;
	ncb.ncb_callname[2] = 100;
	ncb.ncb_lana_num = lana;

	UCHAR uRet = Netbios(&ncb);
	if(uRet == NRC_GOODRET)
		return TRUE;

	::SetLastError(uRet);
	return FALSE;
}


static BOOL GetAdapterStatus(UCHAR lana, UCHAR uMACAddress[])
{
	NCB ncb;
	BYTE buffer[lNAME_SIZE+2];
	ADAPTER_STATUS *pAS;

	::ZeroMemory(&ncb, sizeof(NCB));
	::ZeroMemory(buffer, lNAME_SIZE+2);

	ncb.ncb_command = NCBASTAT;
	ncb.ncb_buffer = buffer;
	ncb.ncb_length = lNAME_SIZE;
	ncb.ncb_callname[0] = '*';
	ncb.ncb_lana_num = lana;

	UCHAR uRet = Netbios(&ncb);
	if(uRet == NRC_GOODRET)
	{
		pAS = (ADAPTER_STATUS *)buffer;
		memcpy(uMACAddress, &(pAS->adapter_address), 6);
		return TRUE;
	}
	
	::SetLastError(uRet);
	return FALSE;
}

static void GetMacAddress()
{
	// Ensure buffer size is big enough to hold the address
	TCHAR szBuffer[18];
	DWORD dwSize = 18;

	NCB ncb;
	LANA_ENUM lenum;
	UCHAR uMACAddress[6];
	int i;
	int iLEnumCnt = 1;
	UCHAR uRASAdapterAddress[6] = { 0x44, 0x45, 0x53, 0x54, 0x0, 0x0 };  // DEST

	::ZeroMemory(&ncb, sizeof(NCB));
	::ZeroMemory(&lenum, sizeof(lenum));

        // Helper function using GetVersionEx()
	if(false) //IsOSPlatformNT())
	{
		// NT or better supports adapter enumeration
		ncb.ncb_command = NCBENUM;
		ncb.ncb_buffer = (UCHAR *)&lenum;
		ncb.ncb_length = sizeof(lenum);

		UCHAR uRet = Netbios(&ncb);

		if(uRet == NRC_GOODRET) 
		{
			iLEnumCnt = (int)lenum.length;
		}
	}
	else
	{
		// Can't do enumeration, so we'll pretend and query the first adapter only
		lenum.length = (UCHAR)iLEnumCnt;

		for(i=0; i<iLEnumCnt; ++i)
			lenum.lana[i] = (UCHAR)i;
	}

	for(i = 0; i < iLEnumCnt; ++i) 
	{
		if(ResetAdapter(lenum.lana[i]))
		{
			if (GetAdapterStatus(lenum.lana[i], uMACAddress))
			{
				// ignore RAS adapter address, we want MAC
				if (memcmp(uMACAddress, uRASAdapterAddress, 6) != 0)
				{
					wsprintf(szBuffer, "%02X:%02X:%02X:%02X:%02X:%02X", (int)uMACAddress[0], (int)uMACAddress[1], (int)uMACAddress[2], (int)uMACAddress[3], (int)uMACAddress[4], (int)uMACAddress[5]);

				}
			}
		}
	}
}
#endif
 
};


#endif // com_sleepless_win_windows_cpp
