

var sys = require('sys')
var net = require('net')
net.Stream.prototype.send = function(msg) { this.write(JSON.stringify(msg)+"\0"); }
var fs = require('fs')
var http = require('http')
var url = require('url')
var misc = require("./misc")
var DBClient = require('./mysql').Client
require("./log")
logLevel = 1



process.on('uncaughtException', function (e) {
	log1("****** UNCAUGHT EXCEPTION ******** "+e+": "+e.stack)
});




// make a connection pool out of this ?
var dbHost = "pdb.familyvillagegame.com"
var dbUser = "mfv"
var dbPass = "ancestor1"
var dbDB = "fishisle"
var dbClient = null
var dbQueries = 0
var dbLastConnect = 0
function dbExec(sql, param, cb) {
	log1('dbExec: '+sql+" -- "+human(param))
	if(! dbClient ) {
		log1("dbExec: connecting "+dbUser+"@"+dbHost)
		dbClient = new DBClient();
		dbClient.debug = false;
		dbClient.host = dbHost;
		dbClient.user = dbUser;
		dbClient.password = dbPass;
		dbClient.connect();
		dbClient.query('USE '+dbDB);
		dbLastConnect = time()
	}
	else {
		log1("dbExec: (reuse)")
	}
	dbClient.query(sql, param, cb)
	dbQueries++
	if(time() - dbLastConnect > 60*60) {
		log1("dbExec: forcing db reconnect")
		dbClient.end()
		dbClient = null;
	}
}


var mimeTypes = {
	html: "text/html",
	xml: "text/xml",
	js: "application/javascript",
}

var env = null, rev = null
var port = 4440
var serverStart = 0
var numPlayers = 0;
var users = {}
var bytesIn = 0
var bytesOut = 0
var msgsIn = 0
var msgsOut = 0
var transactions = 0
var DROP_SECS = 15
var CUCKOO_SECS = 5



// runs through users object, drops idle clients, and updates numPlayers
drop = function() {
	setTimeout(drop, DROP_SECS * 1000)
	var p = 0
	for (var uid in users) {
		var user = users[uid];
		if(millis() - user.ts > 1000 * DROP_SECS) {
			log2("dropped "+uid+": "+(user.name || "--"))
			delete users[uid]
		}
		else {
			p++;
		}
	}
	numPlayers = p
}


cuckoo = function() {
	setTimeout(cuckoo, CUCKOO_SECS * 1000)
	log1("cuckoo "+(new Date().toUTCString())+" players: "+numPlayers)

	var s = ""+bytesIn
	s += ","+bytesOut
	s += ","+numPlayers
	s += ","+dbQueries		// db queries
	s += ","+Math.floor(serverStart / 1000)
	s += ","+transactions
	s += ","+0
	s += ","+0
	s += ","+time()
	s += ","+0
	s += "\n"
	log1("status = "+s)
	fs.writeFile("/tmp/status.txt", s, function(err) { if(err) throw err })

}


mindy = function(user, msg, out) {

	var MINDY_PORT = 9900;
	var MINDY_HOST = "localhost";
	var sock = net.createConnection(MINDY_PORT, MINDY_HOST);
	var jout = ""
	sock.on('error', function(e) {
		throw "Error communicating with mindy: "+e
	})
	sock.on('close', function() {
		log3("mindy sock: closed");
		log1("TRIXY <-- "+jout+" <-- MINDY");
		var aa = JSON.parse(jout)
		aa.iter(function(i,v) {
			out.push(v)
		})
	})
	sock.on('connect', function() {
		log3("mindy sock: connected to "+MINDY_HOST+":"+MINDY_PORT);
		sock.setEncoding('utf8');
		var jin = JSON.stringify([msg])
		log1("TRIXY --> "+jin+" --> MINDY")
		sock.write(jin)
		sock.end()
	})
	sock.on('data', function(data) {
		jout += data.toString("utf8", 0, data.length);
	})
}

trixy = function(user, msg, out) {

	var m = msg.m
	var uid = msg.uid
	var q = msg.q || null

	if(m == "ping") {

		msg.m = "pong"
		msg.ts = millis()
		msg.svr = "trixy"
		delete msg.uid
		out.push(msg) 
		return true;

	}

	if(m == "sendmail") {

		var box = msg.box
		var to = msg.to

		var sql = "insert into postoffice (master_from, master_to, box) values (?, ?, ?)"
		dbExec(sql, [msg.from, msg.to, msg.box], function(e, r, f) {
			if(e) {
				out.push({t:millis(), q:q, r:1, m:m+" fail", x:""+e});
			}
			out.push({
				r:0, m:m+" ok",
				q:q,
				t:millis(),
				msgid:r.insertId
			})
		})
		return true

	}

	if(m == "getmail") {

		var msgid = msg.msgid

		if(msgid) {
			var sql = "select master_from, master_to, box, sent from postoffice where master_to=? and id=? limit 1"
			dbExec(sql, [user.uid, msgid], function(e, r, f) {
				if(e) {
					out.push({t:millis(), q:q, r:1, m:m+" fail", x:""+e});
				}
				else {
					var msg = r[0]
					out.push({t:millis(), q:q, r:0, m:m+" ok",
						msg:{from:msg.master_from, box:msg.box, sent:msg.sent}
					});
					sql = "update postoffice set delivered=now() where id=?"
					dbExec(sql, [msgid], function(e, r, f) {
						if(e) throw e
					})
				}
			})
		}
		else {
			var sql = "select id from postoffice where master_to=? order by sent asc limit 100"
			dbExec(sql, [user.uid], function(e, r, f) {
				if(e) {
					out.push({t:millis(), q:q, r:1, m:m+" fail", x:""+e});
				}
				else {
					var a = []
					r.iter(function(i,v) { a.push(v.id) })
					out.push({t:millis(), q:q, r:0, m:m+" ok",
						msgids:a
					})
				}
			})
		}

		return true

	}


	if(m == "login") {

		user.sid = sha1("S"+millis())
		out.push({m:"setsid", sid:user.sid})
		return false;

	}

	if(m == "status") {

		msg.ts = millis()
		msg.svr = "trixy"
		msg.start = serverStart
		msg.players = numPlayers
		msg.messagesin = msgsIn
		msg.messagesout = msgsOut
		msg.bytesin = bytesIn
		msg.bytesout = bytesOut
		msg.transactions = transactions
		out.push(msg)
		return true;

	}

	return false;
}


pumpOut = function(res, out) {
	msgsOut += out.length
	log2("pump: outgoing msgs: "+out.length)
	var jout = o2j(out)
	log1("CLIENT <--  "+jout+" <-- TRIXY");

	res.writeHead(200, {'Content-Type': 'text/plain'})
	res.end(jout)

	bytesOut += jout.length

	while(out.length)
		out.shift()
}


getUser = function(uid) {
	var user = users["u-"+uid];
	if(!user) {
		log3("making new user object: u-"+uid)
		user = {
			uid: uid,
			out: [],
			ts: millis(),
			sid: sha1("S"+millis())
		}
		users["u-"+uid] = user;
	}
	return user
}

sendFile = function(res, f, mime) {
	log1("sending "+mime+" file "+f)
	fs.readFile(f, function(err, data) {
		if (err)
			throw err
		res.writeHead(200, {'Content-Type':mime})
		res.end(data);
	})
}


tx = function(req, res) {

	transactions++

	var rip = req.socket.remoteAddress+":"+req.socket.remotePort
	log4("connect from "+rip)

	var method = req.method
	var u = url.parse(req.url, true)
	var path = u.pathname
	var query = u.query
	log4("method="+method+" path="+path+" query="+query)



	if(path != "/") {

		var m  = path.match(/^\/(crossdomain.xml|test.html|monitor.html|jquery.js)$/)
		if(m) {
			var f = m[1]
			if(!f.match(/\.\./)) {
				m = f.match(/\.([A-Za-z0-9]+)$/)
				if(m) {
					var ext = mimeTypes[m[1]]
					sendFile(res, f, ext)
					return;
				}
			}
		}
	
		log4("returning 404")
		res.writeHead(404, {'Content-Type':'text/plain'})
		res.end("FILE NOT FOUND\n");

		return;

	}



	try {

		if(method == "GET") {

			if(query) {

				var jin = unescape(query.json)
				log1("CLIENT --> "+jin+" --> TRIXY")

				bytesIn += jin.length

				var msgs = JSON.parse(jin)
				var n = msgs.length
				log2("incoming msgs: "+n)

				var out = null
				var user = null

				msgs.iter(function(i, msg) {

					msgsIn++

					user = getUser(msg.uid)
					user.ts = millis()
					out = user.out

					log2("msgs["+i+"] = "+msg.m)
					if(!trixy(user, msg, out)) {
						mindy(user, msg, out)		// trixy didn't handle it, so pass to mindy
					}

				})

				pumpOut(res, out)

			}
			else {
				throw "Empty query string"
			}

		}
		else
		if(method == "POST") {

			throw "POST transactions not yet implemented"

		}
		else
			throw method+" is unsupported"


	} catch(e) {
		log1("****** EXCEPTION ******** "+e+": "+e.stack)
		pumpOut(res, [{m:"error",x:""+e,t:""+(new Date())}])
	}

}


init = function(err, cfg) {
	log1("Trixy "+(new Date().toUTCString())+" -------------------");
	if (err)
		throw err
	var a = (""+cfg).split(",");
	if(a.length < 2)
		throw "bad config: "+cfg;
	env = a[0]
	rev = a[1]

	if(env == "dev")
		dbHost = 'sdb.familyvillagegame.com';
	if(env == "stg")
		dbHost = 'sdb.familyvillagegame.com';

	log1("dbHost="+dbHost+", dbDB="+dbDB+", dbUser="+dbUser)

	serverStart = new Date().getTime() 

	http.createServer(tx).listen(port);
	log1('server '+env+'/'+rev+' listening on '+port)

	drop()		// prime the client dropping timer
	cuckoo()	// primes the cuckoo clock
}


fs.readFile("/var/www/html/env.txt", init)


